'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.returnChartData = exports.renderChart = exports.getChartSettings = undefined;

var _apiBaseUrl = require('../constants/apiBaseUrl');

/* -------- getChartSettings ---------- */
var getChartSettings = exports.getChartSettings = function getChartSettings(request) {
  return fetch(_apiBaseUrl.API_DASHBOARD_URL + "/getChartSettings", {
    method: 'POST',
    headers: {
      'Accept': 'application/json',
      'Content-Type': 'application/json'
    },
    body: request
  }).then(function (res) {
    return res.json();
  }).then(function (results) {
    return results;
  });
};

/* -------- renderChart ---------- */
var renderChart = exports.renderChart = function renderChart(request) {
  return fetch(_apiBaseUrl.API_DASHBOARD_URL + "/renderChart", {
    method: 'POST',
    headers: {
      'Accept': 'application/json',
      'Content-Type': 'application/json'
    },
    body: request
  }).then(function (res) {
    return res.json();
  }).then(function (results) {
    return results;
  });
};

/* -------- returnChartData ---------- */
var returnChartData = exports.returnChartData = function returnChartData(request) {
  return fetch(_apiBaseUrl.API_RESULTSET_URL + "/returnChartData", {
    method: 'POST',
    headers: {
      'Accept': 'application/json',
      'Content-Type': 'application/json'
    },
    body: JSON.stringify(request)
  }).then(function (res) {
    return res.json();
  }).then(function (results) {
    return results;
  });
};