'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.getAutocomplete = exports.getFilterFields = undefined;

var _apiBaseUrl = require('../constants/apiBaseUrl');

/* -------- getChartSettings ---------- */
var getFilterFields = exports.getFilterFields = function getFilterFields(queryParam) {
    return fetch(_apiBaseUrl.API_RESULTSET_URL + "/loadFilter", { //platform-services //prismmicro-resultset
        method: 'POST',
        headers: {
            'Accept': 'application/json',
            'Content-Type': 'application/json'
        },
        body: JSON.stringify(queryParam)
    }).then(function (res) {
        return res.json();
    }).then(function (results) {
        return results;
    });
};

/* -------- getAutocomplete ---------- */
var getAutocomplete = exports.getAutocomplete = function getAutocomplete(queryParam, URL) {

    return fetch(_apiBaseUrl.API_AUTOCOMPLETE_URL + "/" + URL, {
        method: 'POST',
        headers: {
            'Accept': 'application/json',
            'Content-Type': 'application/json'
        },
        body: JSON.stringify(queryParam)
    }).then(function (res) {
        return res.json();
    }).then(function (results) {
        return results;
    });
};

/* -------- getAutocompleteNLP ---------- */
// export const getAutocomplete = (queryParam) => {

//   return fetch(API_AUTOCOMPLETE_URL + "/suggestNLPToken", { 
//       method: 'POST',
//       headers: {
//           'Accept': 'application/json',
//           'Content-Type': 'application/json',
//       },
//       body: JSON.stringify(queryParam)
//   })
//   .then(res => res.json())
//   .then(results => (results));
// }