'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.getDashboard = exports.getResultSetData = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _apiBaseUrl = require('../constants/apiBaseUrl');

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

/* -------- resultset - returnData ---------- */
var getResultSetData = exports.getResultSetData = function getResultSetData(_queryParam, dataTableConfig) {
    return fetch(_apiBaseUrl.API_RESULTSET_URL + "/returnData", {
        method: 'POST',
        headers: {
            'Accept': 'application/json',
            'Content-Type': 'application/json'
        },
        body: JSON.stringify(_queryParam)
    }).then(function (res) {
        return res.json();
    }).then(function (posts) {

        var dataTable = _extends({}, dataTableConfig);
        if (posts.data && posts.config) {
            posts.filters = _queryParam.filters;
            dataTable = _extends({}, dataTableConfig, {
                header: _extends({}, dataTableConfig.header, {
                    config: [].concat(_toConsumableArray(posts.config))
                }),
                body: _extends({}, dataTableConfig.body, posts.data),
                filters: [].concat(_toConsumableArray(posts.filters))
            });
        }
        return dataTable;
    });
};
var getDashboard = exports.getDashboard = function getDashboard(request) {
    return fetch(_apiBaseUrl.API_DASHBOARD_URL + "/getDashboard", {
        method: 'POST',
        headers: {
            'Accept': 'application/json',
            'Content-Type': 'application/json'
        },
        body: request
    }).then(function (res) {
        return res.json();
    }).then(function (results) {
        return results;
    });
};