'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deleteTab = exports.saveTab = exports.createTab = exports.getTab = undefined;

var _apiBaseUrl = require('../constants/apiBaseUrl');

/* -------- get tab ---------- */
var getTab = exports.getTab = function getTab(request) {
  return fetch(_apiBaseUrl.API_DASHBOARD_URL + "/getTab", {
    method: 'POST',
    headers: {
      'Accept': 'application/json',
      'Content-Type': 'application/json'
    },
    body: request
  }).then(function (res) {
    return res.json();
  }).then(function (results) {
    return results;
  });
};
/* -------- create tab ---------- */
var createTab = exports.createTab = function createTab(request) {
  return fetch(_apiBaseUrl.API_DASHBOARD_URL + "/createTab", {
    method: 'POST',
    headers: {
      'Accept': 'application/json',
      'Content-Type': 'application/json'
    },
    body: JSON.stringify(request)
  }).then(function (res) {
    return res.json();
  }).then(function (results) {
    return results;
  });
};

/* -------- save tab ---------- */
var saveTab = exports.saveTab = function saveTab(request) {
  return fetch(_apiBaseUrl.API_DASHBOARD_URL + "/saveTab", {
    method: 'POST',
    headers: {
      'Accept': 'application/json',
      'Content-Type': 'application/json'
    },
    body: JSON.stringify(request)
  }).then(function (res) {
    return res.json();
  }).then(function (results) {
    return results;
  });
};
/* -------- delete tab ---------- */
var deleteTab = exports.deleteTab = function deleteTab(request) {
  return fetch(_apiBaseUrl.API_DASHBOARD_URL + "/deleteTab", {
    method: 'POST',
    headers: {
      'Accept': 'application/json',
      'Content-Type': 'application/json'
    },
    body: request
  }).then(function (res) {
    return res.json();
  }).then(function (results) {
    return results;
  });
};