'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deleteWidget = exports.saveWidget = exports.addWidget = undefined;

var _apiBaseUrl = require('../constants/apiBaseUrl');

/* -------- addWidget ---------- */
var addWidget = exports.addWidget = function addWidget(request) {
  return fetch(_apiBaseUrl.API_DASHBOARD_URL + "/addWidget", {
    method: 'POST',
    headers: {
      'Accept': 'application/json',
      'Content-Type': 'application/json'
    },
    body: JSON.stringify(request)
  }).then(function (res) {
    return res.json();
  }).then(function (results) {
    return results;
  });
};

var saveWidget = exports.saveWidget = function saveWidget(request) {
  return fetch(_apiBaseUrl.API_DASHBOARD_URL + "/saveWidget", {
    method: 'POST',
    headers: {
      'Accept': 'application/json',
      'Content-Type': 'application/json'
    },
    body: JSON.stringify(request)
  }).then(function (res) {
    return res.json();
  }).then(function (results) {
    return results;
  });
};

var deleteWidget = exports.deleteWidget = function deleteWidget(request) {
  return fetch(_apiBaseUrl.API_DASHBOARD_URL + "/removeWidget", {
    method: 'POST',
    headers: {
      'Accept': 'application/json',
      'Content-Type': 'application/json'
    },
    body: request
  }).then(function (res) {
    return res.json();
  }).then(function (results) {
    return results;
  });
};