'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Snackbar = require('@material-ui/core/Snackbar');

var _Snackbar2 = _interopRequireDefault(_Snackbar);

var _navigationBar = require('./scripts/navigationBar');

var _navigationBar2 = _interopRequireDefault(_navigationBar);

var _tabAction = require('./actions/tabAction');

var _layoutAction = require('./actions/layoutAction');

var _notifications = require('./scripts/commonComponents/notifications');

var _notifications2 = _interopRequireDefault(_notifications);

var _apiBaseUrl = require('./constants/apiBaseUrl');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CustomDashboard = function (_PureComponent) {
  _inherits(CustomDashboard, _PureComponent);

  function CustomDashboard() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, CustomDashboard);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = CustomDashboard.__proto__ || Object.getPrototypeOf(CustomDashboard)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      showLayout: false,
      toastOpen: false,
      toastMessage: null,
      toastVariant: null,
      datas: {
        appId: _this.props.datas.appId,
        dashboardId: _this.props.datas.dashboardId
      }
    }, _this.showNotification = function (res, _type) {

      _this.setState({
        toastOpen: true,
        toastMessage: res.message,
        toastVariant: _type
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(CustomDashboard, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _this2 = this;

      (0, _apiBaseUrl.setDashboardURL)(this.props.dashboardURL);
      (0, _apiBaseUrl.setResultSetURL)(this.props.resultSetURL);
      (0, _apiBaseUrl.setAutoCompleteURL)(this.props.autoCompleteURL);
      if (this.props.dashboardData && this.props.dashboardData.dashboardId) {
        this.setState({
          showLayout: true,
          datas: {
            appId: this.props.dashboardData.appId.appId,
            dashboardId: this.props.dashboardData.dashboardId,
            tabId: this.props.dashboardData.tabs[0].tabId,
            layoutId: this.props.dashboardData.tabs[0].layout.layoutId
          }
        });
      } else {
        var _createTabReq = {
          "dashBoardId": this.props.datas.dashboardId,
          "tabId": this.props.datas.dashboardId + "_main",
          "layoutId": this.props.datas.dashboardId + "_main_layout",
          "tabName": "Main",
          "tabSequence": 0,
          "theme": ""
        };
        var _createLayoutReq = {
          "layoutId": this.props.datas.dashboardId + "_main_layout",
          "tabId": this.props.datas.dashboardId + "_main",
          "theme": ""
        };
        (0, _tabAction.createTab)(_createTabReq).then(function (res) {
          if (res.error) {
            _this2.showNotification(res, "error");
          } else {
            (0, _layoutAction.createLayout)(_createLayoutReq).then(function (res) {
              if (res.error) {
                _this2.showNotification(res, "error");
              } else {
                _this2.setState({
                  showLayout: true,
                  datas: _extends({}, _this2.state.datas, {
                    "tabId": _createLayoutReq.tabId,
                    "layoutId": _createLayoutReq.layoutId
                  })
                });
              }
            }).catch(function (err) {
              _this2.showNotification(err, "error");
            });
          }
        }).catch(function (err) {
          _this2.showNotification(err, "error");
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _state = this.state,
          showLayout = _state.showLayout,
          datas = _state.datas,
          toastOpen = _state.toastOpen,
          toastVariant = _state.toastVariant,
          toastMessage = _state.toastMessage;
      var dashboardData = this.props.dashboardData;

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          _Snackbar2.default,
          {
            anchorOrigin: { vertical: "top", horizontal: "right" },
            open: toastOpen,
            autoHideDuration: 3000,
            onClose: function onClose() {
              _this3.setState({ toastOpen: false });
            }
          },
          _react2.default.createElement(_notifications2.default, {
            variant: toastVariant,
            message: toastMessage,
            onClose: function onClose() {
              _this3.setState({ toastOpen: false });
            }
          })
        ),
        showLayout && _react2.default.createElement(_navigationBar2.default, {
          allowEdit: this.props.allowEdit,
          datas: datas,
          tabDatas: dashboardData.tabs || []
        })
      );
    }
  }]);

  return CustomDashboard;
}(_react.PureComponent);

exports.default = CustomDashboard;