"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _rlReactGenericTable = require("rl-react-generic-table");

var _rlReactGenericTable2 = _interopRequireDefault(_rlReactGenericTable);

var _drawCharts = require("./drawCharts");

var _drawCharts2 = _interopRequireDefault(_drawCharts);

var _pivotTable = require("./pivotTable");

var _pivotTable2 = _interopRequireDefault(_pivotTable);

var _materialIcons = require("./commonComponents/materialIcons");

var _materialIcons2 = _interopRequireDefault(_materialIcons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WidgetContent = function (_PureComponent) {
  _inherits(WidgetContent, _PureComponent);

  function WidgetContent() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, WidgetContent);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = WidgetContent.__proto__ || Object.getPrototypeOf(WidgetContent)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      widData: {},
      settings: {}
    }, _this.verifyWidgetSettingsValues = function (_widDataArr) {
      var _widData = _widDataArr;
      var _settings = {};
      var _widDataDetls = _widData.widgetDetails || _widData;
      _widDataDetls.widgetSettings && _widDataDetls.widgetSettings.map(function (obj) {
        var iconStyle = void 0;
        if (obj.fieldId === 'iconStyle') {
          try {
            iconStyle = obj.defaultValue ? JSON.parse(obj.defaultValue.replace(/'/g, "\"")) : {};
          } catch (err) {
            iconStyle = {};
            console.warn("iconStyle JSON is wrong");
          }
        }
        _settings[obj.fieldId] = iconStyle ? iconStyle : obj.defaultValue;
        return obj;
      });
      return { _widData: _widData, _settings: _settings };
    }, _this.hardReloadWidgetComponents = function (_widDataArr, _timeOut) {
      var _this$verifyWidgetSet = _this.verifyWidgetSettingsValues(_widDataArr),
          _widData = _this$verifyWidgetSet._widData,
          _settings = _this$verifyWidgetSet._settings;

      setTimeout(function () {
        _this.setState({
          widData: _widData,
          settings: _settings
        });
      }, _timeOut);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(WidgetContent, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.hardReloadWidgetComponents(this.props.widData, 1000);
    }

    /* componentWillReceiveProps(props) {
      this.hardReloadWidgetComponents(props.widData, 1500);
    } */

  }, {
    key: "render",
    value: function render() {
      var _state = this.state,
          widData = _state.widData,
          settings = _state.settings;


      return _react2.default.createElement(
        "div",
        { style: { overflow: "auto", height: widData.height + "px" } },
        widData.contentType === "gridtable" && _react2.default.createElement(
          "div",
          { style: { overflow: "auto", height: widData.height + "px" } },
          _react2.default.createElement(
            "div",
            { style: {
                float: "left",
                padding: "5px 20px 20px 20px"
              } },
            _react2.default.createElement(_rlReactGenericTable2.default, { tableData: widData.contents })
          )
        ),
        widData.contentType === "pivottable" && widData.contents && widData.widgetDetails && _react2.default.createElement(
          "div",
          { style: { overflow: "auto", height: widData.height + "px" } },
          _react2.default.createElement(_pivotTable2.default, {
            tableData: widData.contents.data,
            tableDimention: widData.widgetDetails.chartDimension,
            settings: widData.widgetSettings
          })
        ),
        widData && widData.contents && widData.contentType === "tilecard" && widData.contents[0].data.map(function (obj, _ind) {
          var tileCount = "",
              _startSymbol = null,
              _endSymbol = null;
          if (settings.numberFormat) {
            tileCount = Number(obj[Object.keys(obj)[0]]);
            var _formatArr = settings.numberFormat.toLowerCase().split("-");
            _startSymbol = _formatArr[1] ? _formatArr[1] : null;
            switch (_formatArr[0].toLowerCase()) {
              case 'comma':
                tileCount = ("" + tileCount).replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1,');
                break;
              case 'trillion':
                tileCount = ("" + tileCount / Math.pow(10, 12)).replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1,');
                _endSymbol = "T";
                break;
              case 'billion':
                tileCount = ("" + tileCount / Math.pow(10, 9)).replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1,');
                _endSymbol = "B";
                break;
              case 'million':
                tileCount = ("" + tileCount / Math.pow(10, 6)).replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1,');
                _endSymbol = "M";
                break;
              case 'exponential':
                tileCount = "" + tileCount.toExponential(2);
                break;
              case 'decimal':
                tileCount = "" + tileCount.toFixed(2);
                break;
            }
          }
          return _react2.default.createElement(
            "div",
            { key: "widget" + _ind, style: {
                textAlign: "center",
                marginTop: "10%",
                fontSize: settings && settings.bodyFontSize,
                color: settings && settings.textColor,
                paddingTop: "2px",
                paddingBottom: "20px"
              } },
            _react2.default.createElement(_materialIcons2.default, {
              icon: settings.icon,
              style: settings.iconStyle || {}
            }),
            _react2.default.createElement(
              "div",
              null,
              _react2.default.createElement(
                "p",
                { style: { fontSize: settings && settings.headerFontSize + "px" } },
                widData.widgetDetails.basicChart && widData.widgetDetails.basicChart.caption
              ),
              _react2.default.createElement(
                "text",
                { style: { fontSize: settings && settings.footerFontSize + "px" } },
                settings.prefix && settings.prefix + "  ",
                _react2.default.createElement(
                  "strong",
                  null,
                  _startSymbol
                ),
                tileCount ? tileCount : obj[Object.keys(obj)[0]],
                _react2.default.createElement(
                  "strong",
                  null,
                  _endSymbol
                ),
                settings.suffix && "  " + settings.suffix
              )
            )
          );
        }),
        widData.contentType !== "gridtable" && widData.contentType !== "pivottable" && widData.contentType !== "tilecard" && widData.contents && _react2.default.createElement(_drawCharts2.default, { contents: widData.contents, layout: widData })
      );
    }
  }]);

  return WidgetContent;
}(_react.PureComponent);

exports.default = WidgetContent;