'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _core = require('@material-ui/core');

var _reactGoogleCharts = require('react-google-charts');

require('../styles/style.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = function styles(theme) {
  return {
    chartStyle: {
      '& g path': {
        cursor: 'pointer',
        zIndex: 300
      }
    },
    gaugeChartStyle: {
      '& text': {
        fontSize: '14px'
      }
    }
  };
};

var DrawModules = function (_Component) {
  _inherits(DrawModules, _Component);

  function DrawModules() {
    _classCallCheck(this, DrawModules);

    return _possibleConstructorReturn(this, (DrawModules.__proto__ || Object.getPrototypeOf(DrawModules)).apply(this, arguments));
  }

  _createClass(DrawModules, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          classes = _props.classes,
          contents = _props.contents,
          layout = _props.layout;

      var widgetSet = layout.widgetDetails.widgetSettings;
      var modifiedObj = {};
      widgetSet && widgetSet.map(function (obj, ind) {
        var value = void 0;
        switch (obj && obj.type) {
          case 'object':
            try {
              value = obj.defaultValue ? JSON.parse(obj.defaultValue.replace(/'/g, "\"")) : '';
            } catch (e) {
              console.warn(obj.fieldId + " is not valid JSON.");
              value = '';
            }
            break;
          case 'checkbox':
            value = Boolean(obj.defaultValue);
            break;
          case 'number':
            value = obj.defaultValue ? Number(obj.defaultValue) : 0;
            break;
          default:
            value = obj.defaultValue;
            break;
        }
        if (value) {
          modifiedObj[obj.fieldId] = value;
        }
      });
      var additionalStyle = modifiedObj && modifiedObj.additionalStyle;
      delete modifiedObj['additionalStyle'];

      return _react2.default.createElement(
        'div',
        null,
        contents.map(function (_config, index) {
          return _react2.default.createElement(
            'div',
            { key: "chart-" + _config.chart.type + "_" + index },
            _react2.default.createElement(
              'div',
              { style: { position: "relative", height: layout.height } },
              _react2.default.createElement(_reactGoogleCharts.Chart, {
                className: _config.chart.type.toLowerCase() === 'gauge' ? classes.gaugeChartStyle : classes.chartStyle,
                chartType: _config.chart.type,
                width: Number(_config.chartWidth) > Number(layout.width) ? layout.width : _config.chartWidth || "100%",
                height: layout.height - 5 + "px",
                data: _config.data,
                style: additionalStyle,
                loader: _react2.default.createElement(
                  'div',
                  { style: { position: 'absolute', top: '45%', left: '30%' } },
                  'Loading Chart'
                ),
                options: modifiedObj
                // explorer={{axis:'Vertical'}}
                /* chartEvents={[
                  {
                    eventName: 'select',
                    callback: ({ chartWrapper }) => {
                      const chart = chartWrapper.getChart();
                      const selection = chart.getSelection();
                    },
                  },
                ]} */
                , rootProps: { 'data-testid': '1' }
              })
            )
          );
        })
      );
    }
  }]);

  return DrawModules;
}(_react.Component);

exports.default = (0, _core.withStyles)(styles)(DrawModules);