'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _downshift = require('downshift');

var _downshift2 = _interopRequireDefault(_downshift);

var _core = require('@material-ui/core');

var _TextField = require('@material-ui/core/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _Paper = require('@material-ui/core/Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _MenuItem = require('@material-ui/core/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

require('./commonComponents/genericMethods');

var _filterAction = require('../actions/filterAction.js');

require('../styles/dialog.scss');

var _Tooltip = require('@material-ui/core/Tooltip');

var _Tooltip2 = _interopRequireDefault(_Tooltip);

var _genericReactAutocomplete = require('generic-react-autocomplete');

var _genericReactAutocomplete2 = _interopRequireDefault(_genericReactAutocomplete);

require('react-autocomplete-input/dist/bundle.css');

var _http = require('http');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var styles = function styles(theme) {
  return {
    root: {
      flexGrow: 1
    },
    container: {
      flexGrow: 1,
      position: 'relative',
      marginTop: 10
    },
    paper: {
      position: 'absolute',
      zIndex: 1000,
      marginTop: theme.spacing.unit,
      top: 50,
      left: 0,
      right: 0
    },
    TextInput: {
      // width: '95%',
      padding: '9px',
      borderRadius: '4px',
      borderWidth: '1px',
      background: "#eee",
      /* box-shadow: none; */
      marginTop: '11px',
      marginBottom: '5px'
    },
    textArea: {
      // width: '95%',
      padding: '9px',
      borderRadius: '4px',
      borderWidth: '1px',
      /* box-shadow: none; */
      marginTop: '11px',
      marginBottom: '5px'
    },
    inputRoot: {
      flexWrap: 'wrap'
    },
    inputInput: {
      width: 'auto',
      flexGrow: 1
    }
  };
};

var _assignOperators = ["!=", "="];
var _arithmOperators = ["!=", "=", "in", "is", "is not", "not in"];
var _logicOperators = ["AND", "AND NOT", "OR", "OR NOT", "ORDER BY"];
var suggestions = [];
function renderInput(inputProps) {
  var InputProps = inputProps.InputProps,
      classes = inputProps.classes,
      ref = inputProps.ref,
      selectedItem = inputProps.selectedItem,
      other = _objectWithoutProperties(inputProps, ['InputProps', 'classes', 'ref', 'selectedItem']);

  return _react2.default.createElement(_TextField2.default, _extends({
    variant: 'outlined',
    className: selectedItem.length ? "remove-filter-left-pad" : "filter-text-field",
    InputProps: _extends({
      inputRef: ref,
      classes: {
        root: classes.inputRoot,
        input: classes.inputInput
      }
    }, InputProps)
  }, other));
}
function renderSuggestion(_ref) {
  var suggestion = _ref.suggestion,
      index = _ref.index,
      itemProps = _ref.itemProps,
      highlightedIndex = _ref.highlightedIndex,
      selectedItem = _ref.selectedItem;

  var isHighlighted = highlightedIndex === index;
  var isSelected = (selectedItem || '').indexOf(suggestion.label) > -1;
  return _react2.default.createElement(
    _MenuItem2.default,
    _extends({}, itemProps, {
      key: suggestion.label,
      selected: isHighlighted,
      component: 'div',
      style: {
        fontWeight: isSelected ? 500 : 400
      }
    }),
    suggestion.label
  );
}
function getSuggestions(_value, _appName, _tableName) {
  var _this = this;

  debugger;
  var _request = {
    "app_id": _appName && _appName.value,
    "sentence": _value,
    "tables": [{
      "alias": "en",
      "tableName": _tableName && _tableName.value
    }]
  };
  (0, _filterAction.getAutocomplete)(_request).then(function (res) {
    if (res.error) {
      _this.showNotification(res, "error");
    } else {
      if (res.words) {
        suggestions = [];
        suggestions = res.words.map(function (_data) {
          return { "label": _data };
        });
      } else {
        console.error(res, "error");
      }
    }
  }).catch(function (err) {
    console.error(err, "error");
  });
  return suggestions;
}

var IntegrationDownshift = function (_PureComponent) {
  _inherits(IntegrationDownshift, _PureComponent);

  function IntegrationDownshift() {
    var _ref2;

    var _temp, _this2, _ret;

    _classCallCheck(this, IntegrationDownshift);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this2 = _possibleConstructorReturn(this, (_ref2 = IntegrationDownshift.__proto__ || Object.getPrototypeOf(IntegrationDownshift)).call.apply(_ref2, [this].concat(args))), _this2), _this2.state = {
      inputValue: '',
      selectedItem: '',
      selectedApp: {},
      selectedTable: {},
      spaceRequired: false,
      suggestion: {
        filter: {
          options: [],
          value: ""
        },
        nlpFilter: {
          options: [],
          value: ""
        }
      }
    }, _this2.recieveFiltervalue = function (_propsVal) {
      var _selectedFilter = _propsVal.selectedFilter || '';
      _this2.setState({
        selectedItem: _selectedFilter,
        selectedApp: _propsVal.selectedApp,
        selectedTable: _propsVal.selectedTable
      });
    }, _this2.handleFilterSuggestions = function (field, value) {

      var suggestion = _extends({}, _this2.state.suggestion);
      suggestion[field].value = value;
      _this2.setState({ suggestion: suggestion });
      _this2.props.setFilterValue(value);
    }, _this2.handleKeyDown = function (event) {
      debugger;
      var _this2$state = _this2.state,
          selectedItem = _this2$state.selectedItem,
          inputValue = _this2$state.inputValue;

      var _selectedItem = selectedItem.trim() || inputValue.trim();
      if (_selectedItem.length && event.key === 'Backspace') {
        /* _selectedItem = _selectedItem.split(" "); */
        _selectedItem = _selectedItem.slice(0, _selectedItem.length - 1);
        /* _selectedItem = _selectedItem.join(" "); */
        getSuggestions(_selectedItem, _this2.state.selectedApp, _this2.state.selectedTable);
        // this.props.setFilterValue(_selectedItem);
        _this2.setState({
          selectedItem: _selectedItem,
          inputValue: ''
        });
      }
    }, _this2.handleInputChange = function (event) {
      var selectedItem = _this2.state.selectedItem;

      var _value = selectedItem + event.target.value;
      _assignOperators.map(function (_operator) {
        var _lastInd = -1;
        var _word = _operator.trim().toLowerCase();
        var _currtVal = _value.toLowerCase();
        var _counts = _value.toLowerCase().split(_word).length;
        if (_counts > 1) {
          for (var i = 1; i < _counts; i++) {
            var _currtInd = _currtVal.indexOf(_word, _lastInd + 1);
            if (_currtInd !== -1 && _currtVal.charAt(_currtInd - 1) !== " " && _currtVal.charAt(_currtInd + 1) !== " ") {
              if (_word === "!=") {
                _value = _value.replaceAt(_currtInd, " " + _word + " ");
              } else {
                _value = _value.replaceAt(_currtInd, " " + _word + " ");
              }
            }
            _lastInd = _currtInd;
          }
        }
      });

      getSuggestions(_value, _this2.state.selectedApp, _this2.state.selectedTable);
      _this2.props.setFilterValue(_value);

      _this2.setState({
        inputValue: _value,
        selectedItem: ''
      });
    }, _this2.handleconvertNLPToSQL = function (field) {
      debugger;

      var _request = {
        "app_id": _this2.state.selectedApp.value,
        "sentence": _this2.state.suggestion[field].value,
        "tables": [{
          "alias": "en",
          "tableName": _this2.state.selectedTable.value
        }]
      };
      (0, _filterAction.getAutocomplete)(_request, "convertNLPToSQL").then(function (res) {
        var suggestion = _extends({}, _this2.state.suggestion);
        suggestion["filter"].value = res.query;
        _this2.setState({ suggestion: suggestion });
      });
    }, _this2.handleSelectedOption = function (field, event, value, previousValue) {
      debugger;
      var selectedValue = void 0;

      if (field === "nlpFilter") {
        // let NLPfilterArray= [...this.state.suggestion[field].value];
        selectedValue = value.replace(previousValue, "");
        selectedValue = selectedValue.trim();
        var suggestion = _extends({}, _this2.state.suggestion);
        if (suggestion[field].value.charAt(0) !== '[') {
          suggestion[field].value = "[" + selectedValue + "]";
        } else if (previousValue.charAt(previousValue.length - 1) === '[') {
          suggestion[field].value = previousValue + selectedValue + "]";
        } else {
          suggestion[field].value = previousValue + "[" + selectedValue + "]";
        }
        // suggestion[field].value.push("["+selectedValue+"]");
        _this2.setState({
          suggestion: suggestion
        });
      }
      // this.handleRequestOptions(field, value);
    }, _this2.handleChange = function (item) {
      var _this2$state2 = _this2.state,
          selectedItem = _this2$state2.selectedItem,
          inputValue = _this2$state2.inputValue;

      var _operators = [].concat(_arithmOperators, _logicOperators);
      inputValue = inputValue.trim() || selectedItem.trim();

      if (!_operators.includes(inputValue.split(" ")[inputValue.split(" ").length - 1]) && !_operators.includes(item)) {
        inputValue = inputValue.split(" ").slice(0, inputValue.split(" ").length - 1).join(" ");
      }
      selectedItem = inputValue + " " + item;
      _this2.setState({
        inputValue: '',
        selectedItem: selectedItem
      });
      getSuggestions(selectedItem, _this2.state.selectedApp, _this2.state.selectedTable);
      _this2.props.setFilterValue(selectedItem);
    }, _temp), _possibleConstructorReturn(_this2, _ret);
  }

  _createClass(IntegrationDownshift, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.recieveFiltervalue(this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(props) {
      if (this.state.selectedApp !== props.selectedApp || this.state.selectedTable !== props.selectedTable) {
        this.setState({
          selectedApp: props.selectedApp,
          selectedTable: props.selectedTable
        });
      }
    }
  }, {
    key: 'handleRequestOptions',
    value: function handleRequestOptions(field, part) {
      var _this3 = this;

      debugger;
      var urlContext = void 0;
      if (field === "nlpFilter") {
        urlContext = "suggestNLPToken";
      } else {
        urlContext = "suggestToken";
      }
      console.log('part', part);
      var _request = {
        "app_id": this.state.selectedApp.value,
        "sentence": this.state.suggestion[field].value ? this.state.suggestion[field].value : part,
        "tables": [{
          "alias": "en",
          "tableName": this.state.selectedTable.value
        }]
      };
      (0, _filterAction.getAutocomplete)(_request, urlContext).then(function (res) {
        var suggestion = _extends({}, _this3.state.suggestion);
        suggestion[field].options = res.words;
        debugger;
        // suggestion[field].value = res.words+part;
        _this3.setState({ suggestion: suggestion });
      });
      // getSuggestions(part, this.state.selectedApp, this.state.selectedTable);       // -> "ap", which is part after trigger "@"
      // this.setState({ options: this.state.words });
    }
  }, {
    key: 'render',
    value: function render() {
      var classes = this.props.classes;
      var _state = this.state,
          inputValue = _state.inputValue,
          selectedItem = _state.selectedItem,
          selectedApp = _state.selectedApp,
          selectedTable = _state.selectedTable;

      return _react2.default.createElement(
        'div',
        { className: classes.root },
        _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(_genericReactAutocomplete2.default, {
            onRequestOptions: this.handleRequestOptions.bind(this, 'nlpFilter'),
            className: classes.textArea,
            style: { width: '95%', maxHeight: '50px', maxWidth: '95%' },
            trigger: '',
            handleSelection: this.handleSelectedOption.bind(this, 'nlpFilter'),
            regex: "^^[a-zA-Z0-9!@#$&()\\-`.+,/\"]*$",
            spaceRemovers: []
            // Component="input"
            , placeholder: 'Enter your NLP Filter',
            value: this.state.suggestion.nlpFilter.value
            // value ={this.state.suggestion.nlpFilter.value}
            , options: this.state.suggestion.nlpFilter.options
            // onColumnSelected={ this.suggestionSelected.bind(this, 'nlpFilter')}
            , onChange: this.handleFilterSuggestions.bind(this, 'nlpFilter') }),
          _react2.default.createElement(
            _Tooltip2.default,
            { title: 'Convert NLP to SQL' },
            _react2.default.createElement(
              'i',
              { className: 'nav-icon material-icons material-icons-autorenew', style: { cursor: 'pointer', verticalAlign: 'top', marginTop: '10px' },
                onClick: this.handleconvertNLPToSQL.bind(this, 'nlpFilter') },
              'autorenew'
            )
          )
        ),
        _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(_genericReactAutocomplete2.default, {
            onRequestOptions: this.handleRequestOptions.bind(this, 'filter'),
            className: classes.TextInput,
            style: { width: '100%' },
            handleSelection: this.handleSelectedOption.bind(this, 'filter'),
            trigger: ''
            // spacer= ''
            , regex: "^^[a-zA-Z0-9!@#$&()\\-`.+,/\"]*$",
            spaceRemovers: [],
            Component: 'input',
            placeholder: 'Enter your Filter',
            options: this.state.suggestion.filter.options,
            value: this.state.suggestion.filter.value,
            onChange: this.handleFilterSuggestions.bind(this, 'filter') })
        )
      );
    }
  }]);

  return IntegrationDownshift;
}(_react.PureComponent);

exports.default = (0, _core.withStyles)(styles)(IntegrationDownshift);