'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _core = require('@material-ui/core');

var _materialIcons = require('./commonComponents/materialIcons');

var _materialIcons2 = _interopRequireDefault(_materialIcons);

var _reactDraggable = require('react-draggable');

var _reactDraggable2 = _interopRequireDefault(_reactDraggable);

var _modalDiolog = require('./modalDiolog');

var _modalDiolog2 = _interopRequireDefault(_modalDiolog);

var _widgetAction = require('../actions/widgetAction');

var _chartSettings = require('../actions/chartSettings');

var _notifications = require('./commonComponents/notifications');

var _notifications2 = _interopRequireDefault(_notifications);

var _settingsIcon = require('./settingsIcon');

var _settingsIcon2 = _interopRequireDefault(_settingsIcon);

var _WidgetContent = require('./WidgetContent');

var _WidgetContent2 = _interopRequireDefault(_WidgetContent);

var _datatableConfig = require('../constants/datatableConfig');

var _resultSetAction = require('../actions/resultSetAction');

var _apiBaseUrl = require('../constants/apiBaseUrl');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = function styles(theme) {
  return {
    root: {
      flexGrow: 1,
      display: 'flex',
      justifyContent: 'center'
    },
    marginTop: {
      marginTop: 20
    },
    grid: {
      position: "relative",
      zIndex: 10
    },
    paper: {
      borderRadius: "0px !important",
      /* color: theme.palette.text.secondary, */
      height: 100 / 12 + '%'
    },
    cell: {
      backgroundColor: '#E0E0E0',
      border: '1px solid #D0D0D0',
      userSelect: "none"
    }
  };
};

var GridLayout = function (_PureComponent) {
  _inherits(GridLayout, _PureComponent);

  function GridLayout() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, GridLayout);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = GridLayout.__proto__ || Object.getPrototypeOf(GridLayout)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      drawWidget: false,
      startCell: 0,
      startPageX: 0,
      startPageY: 0,
      moveCell: 0,
      cellSize: 0,
      layoutData: {},
      resizeWidget: false,
      resizePageX: 0,
      resizePageY: 0,
      resizeWidgetIndex: -1,
      resizeMoveCell: 0,
      dragWidget: false,
      dragWidgetId: null,
      openModalDialog: false,
      selectedWidgetIndex: 0,
      toastOpen: false,
      toastMessage: null,
      toastVariant: null,
      dataTable: _extends({}, _datatableConfig.dataTableConfig),
      modalType: "componentModal",
      modalHeader: "Choose Component",
      modalActionType: "Create",
      modalWidth: "md",
      selectedModule: {},
      modalChartSettings: {},
      widgetCaption: null,
      selectedApp: null,
      selectedTable: null,
      selectedDimension: null,
      selectedMeasure: null,
      selectedGanttValues: {},
      selectedColumnDimension: [],
      selectedRowDimension: [],
      selectedFilter: null,
      resetZIndex: false,
      totalGridWidth: 0,
      totalGridHeight: 0,
      widgetsToLoad: []
    }, _this.updateDimensions = function () {
      var _totalGridWidth = document.getElementById('container').clientWidth;
      var _totalGridHeight = document.getElementById('container').clientHeight;
      var _height = Math.floor(document.getElementById('container').clientWidth / 24);
      _this.setState({
        totalGridWidth: _totalGridWidth,
        totalGridHeight: _totalGridHeight,
        cellSize: _height
      });
    }, _this.createTable = function (classes, _index) {
      var tableRows = [],
          tableBody = [],
          table = [],
          cellIndex = 0;
      for (var i = 0; i < 50; i++) {
        var children = [];
        for (var j = 0; j < 24; j++) {
          var _React$createElement;

          cellIndex++;
          children.push(_react2.default.createElement('td', (_React$createElement = {
            key: "cell" + j,
            id: "cell-" + cellIndex,
            index: "cell-" + cellIndex,
            style: { backgroundColor: _this.state.removeBgColor },
            className: classes.cell
          }, _defineProperty(_React$createElement, 'style', { height: _this.state.cellSize - 2, width: _this.state.cellSize }), _defineProperty(_React$createElement, 'onMouseDown', _this.handleMouseDown), _defineProperty(_React$createElement, 'onMouseMove', _this.handleMouseMove), _defineProperty(_React$createElement, 'onMouseUp', _this.handleMouseUp), _React$createElement)));
        }
        tableRows.push(_react2.default.createElement(
          'tr',
          { key: "row" + i, index: "row-" + i },
          children
        ));
      }
      tableBody.push(_react2.default.createElement(
        'tbody',
        { key: "tbody-" + _index, index: "tbody-" + _index },
        tableRows
      ));
      return tableBody;
    }, _this.handleMouseDown = function (event) {
      event.preventDefault;
      if (event.button !== 2) {
        _this.setState({
          drawWidget: true,
          resizeWidget: false,
          dragWidget: false,
          startCell: Number(event.target.getAttribute("index").split('-')[1]),
          startPageX: event.pageX,
          startPageY: event.pageY,
          moveCell: 0
        });
      }
    }, _this.handleMouseMove = function (event) {
      var _cellNo = Number(event.target.getAttribute("index").split('-')[1]);
      if (_this.state.drawWidget && _this.state.startPageX + 1 < event.pageX || _this.state.drawWidget && _this.state.startPageY + 1 < event.pageY) {
        _this.setState({
          moveCell: _cellNo
        });
        _this.calculateBackground(_cellNo);
      }
      if (_this.state.resizeWidget && _this.state.resizePageX + 1 < event.pageX || _this.state.resizeWidget && _this.state.resizePageY + 1 < event.pageY) {
        _this.setState({
          resizeMoveCell: _cellNo
        });
      }
    }, _this.handleMouseUp = function (event) {
      event.preventDefault;
      var _endColumn = Number(event.target.getAttribute("index").split('-')[1]);
      if (event.button !== 2 && _this.state.drawWidget && _this.state.moveCell) {
        _this.setState({
          drawWidget: false,
          moveCell: 0
        });
        _this.handleDrawWidgets(_endColumn);
      }
      if (event.button !== 2 && _this.state.resizeWidget && _this.state.resizeMoveCell) {
        _this.setState({ resizeWidget: false });
        _this.handleResizeWidgets(event);
      }
    }, _this.handleDrawWidgets = function (_endColumn) {
      var _startCellNo = _this.state.startCell;
      var _endCellNo = _endColumn;
      var _startRemainder = _startCellNo % 24 || 24;
      var _endRemainder = _endCellNo % 24 || 24;
      var _startQuotient = Math.floor(_startCellNo / 24 + (_startCellNo % 24 === 0 ? 0 : 1));
      var _endQuotient = Math.floor(_endCellNo / 24 + (_endCellNo % 24 === 0 ? 0 : 1));

      var _layoutItem = _this.state.layoutData.layout || [];
      var _data = {};

      if (_startRemainder <= _endRemainder) {
        _data = {
          height: (_endQuotient - _startQuotient) * _this.state.cellSize - 4,
          width: (_endRemainder + 1 - _startRemainder) * _this.state.cellSize / _this.state.totalGridWidth * 100,
          top: (_startQuotient - 1) * _this.state.cellSize + 2,
          left: (_startRemainder - 1) * _this.state.cellSize / _this.state.totalGridWidth * 100
        };
      } else if (_startRemainder > _endRemainder) {
        _data = {
          height: Math.abs((_startQuotient - _endQuotient) * _this.state.cellSize) - 4,
          width: (_startRemainder + 1 - _endRemainder) * _this.state.cellSize / _this.state.totalGridWidth * 100,
          top: (_startQuotient - 1) * _this.state.cellSize + 2,
          left: (_endRemainder - 1) * _this.state.cellSize / _this.state.totalGridWidth * 100
        };
      }

      var _widPos = _data;
      var _rightPos = 100 - (_widPos.left + _widPos.width);
      var _bottomPos = _this.state.totalGridHeight - (_widPos.top + _widPos.height);

      _data["right"] = _rightPos;
      _data["bottom"] = _bottomPos;

      var _idCreation = _data.height + "_" + _data.width + "_" + _data.top + "_" + _data.left;
      _data.widgetId = _this.props.datas.layoutId + "_widget_" + "_" + _idCreation + "_" + _layoutItem.length;
      _data.isWidgetAdded = false;

      _layoutItem.push(_data);

      _this.setState({
        layoutData: {
          layout: _layoutItem
        }
      });
    }, _this.calculateBackground = function (_cellNo) {
      /* console.log("------------------ calculateBackground --------------------");
      let _remainder = _cellNo % 24 || 24;
      let _quotient = Math.floor(_cellNo / 24) + 1;
      let _startCell = this.state.startCell;
      for (let i = 0; i < _quotient; i++) {
        for (let j = 0; j < _remainder; j++) {
          let cellVal = _startCell + j + (i * 24);
          document.getElementById("cell-" + (cellVal)).style.backgroundColor = "#FFFFFF";
        }
      } */
    }, _this.handlerDraggableStartEvent = function (event, _tabId, _widgetId) {
      event.stopPropagation();
      _this.setState({
        dragWidget: true,
        dragWidgetId: _widgetId,
        resizeWidget: false,
        drawWidget: false
      });
    }, _this.handlerDraggableDragEvent = function (event) {
      event.stopPropagation();
      /* Hnadle Drag Event */
    }, _this.handlerDraggableStopEvent = function (event, _tabId, _widgetId) {
      var _transformData = event.currentTarget.querySelector(".react-draggable-dragging").style.transform;
      if (_transformData) {
        var _posLeft = Number(_transformData.split(",")[0].replace(/[translate(]/g, '').split("px")[0]);
        var _posTop = Number(_transformData.split(",")[1].replace(/[)]/g, '').split("px")[0]);
        if (_this.state.dragWidget && (Math.abs(_posLeft) > 1 || Math.abs(_posTop) > 1)) {

          var _layoutData = _this.state.layoutData,
              _widgetIndex = null;
          _layoutData.layout.map(function (_data, _index) {
            if (_data.widgetId === _widgetId) {
              _widgetIndex = _index;
            }
            return _widgetIndex !== null;
          });

          var posDetails = _layoutData.layout[_widgetIndex];
          posDetails.left = _posLeft / _this.state.totalGridWidth * 100 + Number(posDetails.left);
          posDetails.top = Number(posDetails.top) + _posTop;

          var _rightPos = _this.state.totalGridWidth - (posDetails.left + posDetails.width);
          var _bottomPos = _this.state.totalGridHeight - (posDetails.top + posDetails.height);

          posDetails.right = _rightPos;
          posDetails.bottom = _bottomPos;

          if (_layoutData.layout[_widgetIndex].isWidgetAdded) {
            var _widPos = _layoutData.layout[_widgetIndex].widgetDetails;
            var _rightPos2 = _this.state.totalGridWidth - (_widPos.left + _widPos.width);
            var _bottomPos2 = _this.state.totalGridHeight - (_widPos.top + _widPos.height);

            _layoutData.layout[_widgetIndex].widgetDetails.left = posDetails.left;
            _layoutData.layout[_widgetIndex].widgetDetails.top = posDetails.top;
            _layoutData.layout[_widgetIndex].widgetDetails.right = _rightPos2;
            _layoutData.layout[_widgetIndex].widgetDetails.bottom = _bottomPos2;
            _layoutData.layout[_widgetIndex].widgetDetails.layoutId = _this.props.datas.layoutId;
            (0, _widgetAction.saveWidget)(_layoutData.layout[_widgetIndex].widgetDetails).then(function (res) {
              _layoutData.layout.splice(_widgetIndex, 1, posDetails);
              _this.setState({
                layoutData: _layoutData,
                dragWidget: false
              });
            }).catch(function (err) {
              _this.showNotification(err, "error");
              _this.setState({
                dragWidget: false,
                dragWidgetId: null
              });
            });
          } else {
            _layoutData.layout.splice(_widgetIndex, 1, posDetails);
            _this.setState({
              layoutData: _layoutData,
              dragWidget: false,
              dragWidgetId: null
            });
          }
        }
      }
    }, _this.handleResizeMouseDown = function (event, tabId, widgetId) {
      event.stopPropagation();
      _this.setState({
        resizeWidget: true,
        drawWidget: false,
        dragWidget: false,
        resizePageX: event.pageX,
        resizePageY: event.pageY,
        resizeWidgetIndex: widgetId,
        resizeMoveCell: 0
      });
    }, _this.handleResizeMouseMove = function (event) {
      if (_this.state.resizeWidget) {
        _this.setState({
          resizeMoveCell: Number(event.pageY)
        });
      }
    }, _this.handleResizeMouseUp = function (event, tabId, widgetId) {
      if (event.button !== 2 && _this.state.resizeWidget && _this.state.resizeMoveCell && _this.state.resizeWidgetIndex === widgetId) {
        event.stopPropagation();

        var _boxPosition = event.target.getBoundingClientRect();
        var _layoutData = _extends({}, _this.state.layoutData),
            _widgetIndex = null;
        _layoutData.layout.map(function (_data, _index) {
          if (_data.widgetId === _this.state.resizeWidgetIndex) {
            _widgetIndex = _index;
          }
          return _widgetIndex !== null;
        });

        var posDetails = _layoutData.layout[_widgetIndex];
        var _leftBoxEnd = Math.ceil((event.pageX - _boxPosition.left) / _this.state.cellSize) || 1;
        var _topBoxEnd = Math.floor((event.pageY - _boxPosition.top) / (_this.state.cellSize - 5)) || 1;

        var decreasedWidth = _this.state.cellSize * _leftBoxEnd;
        var decreaseHeight = _this.state.cellSize * _topBoxEnd;

        posDetails.width = decreasedWidth / _this.state.totalGridWidth * 100;
        posDetails.height = decreaseHeight;

        _this.saveResizedWidget(_layoutData, _widgetIndex, posDetails);
      }
    }, _this.handleResizeWidgets = function (event) {
      var stopCellNo = Number(event.target.getAttribute("index").split('-')[1]),
          _leftCellPos = (stopCellNo % 24 || 24) * _this.state.cellSize,
          _topCellPos = Math.floor(stopCellNo / 24) * _this.state.cellSize;

      var _layoutData = _this.state.layoutData,
          _widgetIndex = null;
      _layoutData.layout.map(function (_data, _index) {
        if (_data.widgetId === _this.state.resizeWidgetIndex) {
          _widgetIndex = _index;
        }
        return _widgetIndex !== null;
      });

      var posDetails = _layoutData.layout[_widgetIndex];
      var _leftBoxEnd = Number(posDetails.left) + Number(posDetails.width);
      var _topBoxEnd = Number(posDetails.top) + Number(posDetails.height);

      var widthToIncrease = _leftCellPos / _this.state.totalGridWidth * 100 - _leftBoxEnd;
      var heightToIncrease = _topCellPos - _topBoxEnd;

      posDetails.width = Number(posDetails.width) + widthToIncrease;
      posDetails.height = Number(posDetails.height) + heightToIncrease;

      _this.saveResizedWidget(_layoutData, _widgetIndex, posDetails);
    }, _this.saveResizedWidget = function (_layoutData, _widgetIndex, posDetails) {
      if (_layoutData.layout[_widgetIndex].isWidgetAdded) {
        _layoutData.layout[_widgetIndex].widgetDetails.width = posDetails.width;
        _layoutData.layout[_widgetIndex].widgetDetails.height = posDetails.height;
        _layoutData.layout[_widgetIndex].widgetDetails.layoutId = _this.props.datas.layoutId;

        (0, _widgetAction.saveWidget)(_layoutData.layout[_widgetIndex].widgetDetails).then(function (res) {
          _layoutData.layout.splice(_widgetIndex, 1, posDetails);

          /* if (posDetails.contentType && posDetails.contentType.toLowerCase() === "charts") {
            this.renderChartToWidget(_layoutData.layout[_widgetIndex].widgetDetails, {"chart": "gantt"});
          } */

          _this.setState({
            layoutData: _layoutData,
            resizeWidget: false,
            resizeMoveCell: 0
          });
          _this.refreshWidgetHandler(event, posDetails);
        }).catch(function (err) {
          _this.showNotification(err, "error");
          _this.setState({
            resizeWidgetIndex: null,
            resizeWidget: false,
            resizeMoveCell: 0
          });
        });
      } else {
        setTimeout(function () {
          _layoutData.layout.splice(_widgetIndex, 1, posDetails);
          _this.setState({
            layoutData: _layoutData,
            resizeWidgetIndex: null,
            resizeWidget: false,
            resizeMoveCell: 0
          });
        }, 100);
      }
    }, _this.addChartToWidget = function (_formData, _moduleType, _data, _actionType) {
      var _widgetSettings = (_data.controls && _data.controls.length) > 0 ? _data.controls : [];
      var _selectedData = _this.state.layoutData.layout.filter(function (_data, _index) {
        return _data.widgetId === _this.state.selectedWidgetIndex;
      });
      var _widgetInfo = _selectedData[0];
      var _chartMeasures = [],
          _chartDimensions = [];

      if (_data.controls && _data.controls.length) {
        _data.controls.map(function (_control) {
          for (var field in _formData) {
            if (_control.fieldId === field) {
              _control.defaultValue = _formData[field];
              return _control;
            }
          }
        });
      }

      if (_moduleType.type.toLowerCase() === "gantt") {
        for (var valObj in _formData.selectedGanttValues) {
          if (valObj !== "depends_task_id") {
            var _obj = {
              "dimensionType": "string",
              "field": _formData.selectedGanttValues[valObj].value,
              "widgetId": _widgetInfo.widgetId
            };
            if (valObj === "dependencies") {
              var _measureObj = {
                "aggregationType": valObj,
                "axis": 'x-axis',
                "chartType": _moduleType.type,
                "numericField": _formData.selectedGanttValues[valObj].value
              };
              _chartMeasures.push(_measureObj);
            } else {
              _chartDimensions.push(_obj);
            }
          }
        }
      } else if (_moduleType.type.toLowerCase() === "pivottable") {
        var _columnData = _formData.selectedColumnDimension.filter(function (_data) {
          return _data !== null;
        });
        _columnData.map(function (_col) {
          var _obj = {
            "dimensionType": "column",
            "field": _col.value,
            "widgetId": _widgetInfo.widgetId
          };
          _chartDimensions.push(_obj);
        });

        var _rowData = _formData.selectedRowDimension.filter(function (_data) {
          return _data !== null;
        });
        _rowData.map(function (_row) {
          var _obj = {
            "dimensionType": "row",
            "field": _row.value,
            "widgetId": _widgetInfo.widgetId
          };
          _chartDimensions.push(_obj);
        });

        _formData.selectedMeasure && _formData.selectedMeasure.map(function (_data) {
          var _obj = {
            "aggregationType": _data.type && _data.type.value,
            "axis": "y-axis",
            "chartType": _moduleType.type,
            "numericField": _data.field && _data.field.value
          };
          _chartMeasures.push(_obj);
        });
      } else {
        _chartMeasures = _formData.selectedMeasure && _formData.selectedMeasure.map(function (_data) {
          return {
            "aggregationType": _data.type && _data.type.value,
            "axis": "y-axis",
            "chartType": _moduleType.type,
            "numericField": _data.field && _data.field.value
          };
        });
      }

      var _addRequest = {
        "basicChart": {
          "appId": _formData.selectedApp && _formData.selectedApp.value,
          "autoRefreshInterval": "",
          "caption": _formData.caption,
          "filters": _formData.selectedFilter,
          "dimension": _formData.selectedDimension && _formData.selectedDimension.value,
          "dimensionAxisType": "x-axis",
          "resultsetId": _formData.selectedTable && _formData.selectedTable.value,
          "theme": "",
          "type": _moduleType.type
        },
        "bottom": "",
        "chartMeasures": _chartMeasures,
        "chartDimension": _chartDimensions,
        "height": _widgetInfo.height,
        "layoutId": _this.props.datas.layoutId,
        "left": _widgetInfo.left,
        "name": _moduleType.name,
        "right": "",
        "sequence": 0,
        "theme": "",
        "top": _widgetInfo.top,
        "widgetId": _widgetInfo.widgetId,
        "widgetSettings": _widgetSettings,
        "width": _widgetInfo.width
      };
      if (_actionType.toLowerCase() === "apply") {
        (0, _widgetAction.addWidget)(_addRequest).then(function (res) {
          _this.updateWidgetContent(res, _addRequest);
        }).catch(function (err) {
          _this.showNotification(err, "error");
        });
      } else {
        (0, _widgetAction.saveWidget)(_addRequest).then(function (res) {
          _this.updateWidgetContent(res, _addRequest);
        }).catch(function (err) {
          _this.showNotification(err, "error");
        });
      }
    }, _this.updateWidgetContent = function (res, _addRequest) {
      if (res.error) {
        _this.showNotification(res, "error");
      } else {
        var _layoutData = _this.state.layoutData.layout;
        var _selectedIndex = _layoutData.findIndex(function (_data) {
          return _data.widgetId === _this.state.selectedWidgetIndex;
        });
        var _changeProperty = _layoutData[_selectedIndex];
        _changeProperty.isWidgetAdded = true;
        _changeProperty.widgetDetails = _addRequest;
        _layoutData.splice(_selectedIndex, 1, _changeProperty);

        var _widgetsToLoad = [].concat(_toConsumableArray(_this.state.widgetsToLoad));
        _widgetsToLoad = _widgetsToLoad.filter(function (_wid) {
          return _wid !== _changeProperty.widgetId;
        });
        _this.setState({
          layoutData: {
            layout: _layoutData
          },
          widgetsToLoad: _widgetsToLoad
        });
        if (_addRequest.basicChart.type.toLowerCase() === "gridtable") {
          _this.renderGridTableToWidget(_addRequest);
        } else if (_addRequest.basicChart.type.toLowerCase() === "pivottable") {
          _this.renderPivotTableToWidget(_addRequest);
        } else if (_addRequest.basicChart.type.toLowerCase() === "tilecard") {
          _this.renderTileCardToWidget(_addRequest);
        } else if (_addRequest.basicChart.type.toLowerCase() === "gantt") {
          _this.renderChartToWidget(_addRequest, { "chart": "gantt" });
        } else {
          _this.renderChartToWidget(_addRequest);
        }
        _this.showNotification(res, "success");
      }
    }, _this.renderPivotTableToWidget = function (widget) {
      _this.getRenderChartData(widget, undefined, "pivottable");
    }, _this.renderChartToWidget = function (widget) {
      var _indexes = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      _this.getRenderChartData(widget, _indexes, "charts");
    }, _this.renderTileCardToWidget = function (widget) {
      _this.getRenderChartData(widget, undefined, "tilecard");
    }, _this.getRenderChartData = function (widget) {
      var _indexes = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var _type = arguments[2];

      var _widgetData = _extends({}, widget);
      var _renderReq = {
        "appId": widget.basicChart.appId,
        "chartType": widget.basicChart.type,
        "resultsetId": widget.basicChart.resultsetId,
        "filters": widget.basicChart.filters
      };
      if (widget.basicChart.dimension) {
        _renderReq["dimensions"] = [widget.basicChart.dimension];
      }
      if (_indexes && _indexes.chart === "gantt" && _type === "charts") {
        _renderReq["dimensions"] = [];
        _renderReq["measures"] = [];
        widget.chartDimension.map(function (_data) {
          _renderReq["dimensions"].push(_data.field);
        });
        widget.chartMeasures.map(function (_data) {
          _renderReq["measures"].push({
            "measureField": _data.numericField,
            "measureType": "group concat"
          });
        });
      } else if (_type === "pivottable") {
        _renderReq["dimensions"] = [];
        _renderReq["measures"] = [];
        widget.chartDimension.map(function (_data) {
          _renderReq["dimensions"].push(_data.field);
        });
        widget.chartMeasures.map(function (_data) {
          _renderReq["measures"].push({
            "measureField": _data.numericField,
            "measureType": _data.aggregationType
          });
        });
      } else {
        _renderReq["measures"] = widget.chartMeasures.map(function (_data) {
          return {
            "measureField": _data.numericField,
            "measureType": _data.aggregationType
          };
        });
      }
      (0, _chartSettings.returnChartData)(_renderReq).then(function (res) {
        if (res.error) {

          _this.showNotification(res, "error");
        } else {
          _this.refreshLayoutDataWithContent(_widgetData, res, _type);
        }
      }).catch(function (err) {

        _this.showNotification(err, "error");
      });
    }, _this.renderGridTableToWidget = function (widget) {
      var _widgetData = _extends({}, widget);
      var _queryParam = {
        appId: _widgetData.basicChart.appId,
        resultsetId: _widgetData.basicChart.resultsetId,
        metadata: true,
        pageSize: 5,
        filters: []
      };

      _this.setState({
        dataTable: _extends({}, _this.state.dataTable, {
          mode: _extends({}, _this.state.dataTable.mode, {
            apiConfig: _extends({}, _this.state.dataTable.mode.apiConfig, {
              apiLink: _apiBaseUrl.API_RESULTSET_URL + "/returnData"
            }),
            requiredInfo: {
              appId: _widgetData.basicChart.appId,
              resultsetId: _widgetData.basicChart.resultsetId
            }
          })
        })
      });
      _this.forceUpdate();
      (0, _resultSetAction.getResultSetData)(_queryParam, _extends({}, _this.state.dataTable)).then(function (res) {
        _this.refreshLayoutDataWithContent(_widgetData, res, "gridtable");
      });
    }, _this.refreshLayoutDataWithContent = function (_widgetData, _response, _type) {
      var chartWidth = 0,
          chartHeight = 0,
          _myChartData = [],
          showGaugeHeader = {};
      if (_type !== "gridtable" && _type !== "pivottable") {
        chartWidth = _widgetData.widgetSettings.find(function (_data) {
          return _data.comment.toLowerCase() === "width";
        });
        chartHeight = _widgetData.widgetSettings.find(function (_data) {
          return _data.comment.toLowerCase() === "height";
        });
        showGaugeHeader = _widgetData.widgetSettings.find(function (_data) {
          return _data.fieldId.toLowerCase() === "showfieldheader";
        });
        if (_widgetData.basicChart.type.toLowerCase() === "gauge") {
          _myChartData = _response.data.map(function (_data, _index) {
            var showHeader = "";
            if (Boolean(showGaugeHeader.defaultValue) === true) {
              showHeader = _this.capitalize(Object.keys(_data)[0]);
            } else {
              showHeader = "";
            }
            return [showHeader, Object.values(_data)[0]];
          });
          _myChartData.unshift(["Label", "Value"]);
        } else if (_widgetData.basicChart.type.toLowerCase() === "gantt") {
          var ganttFieldOrder = ["task_id", "task_name", "start_date", "end_date", "duration", "percent_complete", "depends_task_id"];
          var _ganttFirstColumn = [{ type: "string", label: "Task Id" }, { type: "string", label: "Task Name" }, { type: "date", label: "Start Date" }, { type: "date", label: "End Date" }, { type: "number", label: "Duration" }, { type: "number", label: "Percet Complete" }, { type: "string", label: "dependencies" }];

          _myChartData = _response.data.map(function (_data, _index) {
            var _obj = {
              "task_id": _data[ganttFieldOrder[0]],
              "task_name": _data[ganttFieldOrder[1]],
              "start_date": new Date(_data[ganttFieldOrder[2]]),
              "end_date": new Date(_data[ganttFieldOrder[3]]),
              "duration": (parseFloat(_data[ganttFieldOrder[4]]) || 0) * 24 * 60 * 60 * 1000,
              "percent_complete": parseFloat(_data[ganttFieldOrder[5]]) || 0,
              "depends_task_id": _data[ganttFieldOrder[6]]
            };
            return Object.values(_obj);
          });
          _myChartData.unshift(_ganttFirstColumn);
        } else if (_type === 'tilecard') {
          _myChartData = _response.data;
        } else {
          _myChartData = _response.data.map(function (_data, _index) {
            return Object.values(_data);
          });
          _myChartData.unshift(Object.keys(_response.data[0]));
        }
      }

      var _widgetId = _widgetData.widgetId || _this.state.selectedWidgetIndex;
      var _layoutData = _this.state.layoutData;
      if (typeof _widgetId === "string") {
        _widgetId = _layoutData.layout.findIndex(function (_data) {
          return _data.widgetId === _widgetId;
        });
      }
      var _widgetDetails = _layoutData.layout[_widgetId];

      if (_type === "gridtable") {
        _widgetDetails.contents = _extends({}, _response);
        _widgetDetails.contentType = _type;
      } else if (_type === "pivottable") {
        _widgetDetails.contents = _extends({}, _response);
        _widgetDetails.contentType = _type;
      } else {
        _widgetDetails.contents = [{
          chart: _widgetData.basicChart,
          chartWidth: chartWidth && chartWidth.defaultValue.trim() || 0,
          chartHeight: chartHeight && chartHeight.defaultValue.trim() || 0,
          data: _myChartData
        }];
        _widgetDetails.contentType = _type;
      }
      _widgetDetails.widgetDetails = _widgetData;
      /* _widgetDetails.isWidgetAdded = true; */
      _layoutData.layout.splice(_widgetId, 1, _widgetDetails);

      var _widgetsToLoad = [].concat(_toConsumableArray(_this.state.widgetsToLoad));
      _widgetsToLoad.push(_widgetDetails.widgetId);
      _this.setState({
        layoutData: _layoutData,
        widgetsToLoad: _widgetsToLoad
      });
    }, _this.handleRemoveComponent = function (_layoutData) {
      _this.setState({
        layoutData: _layoutData
      });
      _this.forceUpdate();
    }, _this.closeDialogBox = function () {
      _this.setState({
        openModalDialog: false
      });
    }, _this.setSelectedWidgetIdHandler = function (_bool, _widId) {
      _this.setState({
        selectedWidgetIndex: _widId
      });
    }, _this.popoverHandler = function (_bool) {
      _this.setState({
        resetZIndex: _bool
      });
    }, _this.openModalDialogHandler = function (_mObj, _sObjData) {
      if (_sObjData) {
        var _sObj = _sObjData.widgetDetails || _sObjData;
        var _formControls = _mObj.chartSettings.map(function (_valObj, index) {
          _valObj.label = _valObj.comment;
          if (_valObj.type === "checkbox" && _valObj.defaultValue !== "") {
            _valObj.defaultValue = Boolean(_valObj.defaultValue);
          }
          if (index <= _mObj.chartSettings.length / 2) {
            _valObj.section = '1';
          } else {
            _valObj.section = '2';
          }
          return _valObj;
        });

        var _selectedMeasure = [],
            _selectedGanttValues = {},
            _selectedColumnDimension = [],
            _selectedRowDimension = [];
        if (_sObj.basicChart.type.toLowerCase() === "gantt") {
          _sObj.chartDimension.map(function (_data) {
            _selectedGanttValues[_data.field] = {
              label: _data.field,
              value: _data.field
            };
          });
          _sObj.chartMeasures.map(function (_data) {
            _selectedGanttValues[_data.aggregationType] = {
              label: _data.numericField,
              value: _data.numericField
            };
          });
        } else if (_sObj.basicChart.type.toLowerCase() === "pivottable") {
          _sObj.chartDimension.map(function (_data) {
            if (_data.dimensionType === "column") {
              _selectedColumnDimension.push({
                label: _data.field,
                value: _data.field
              });
            } else {
              _selectedRowDimension.push({
                label: _data.field,
                value: _data.field
              });
            }
          });

          _selectedColumnDimension.length === 0 ? _selectedColumnDimension.push(null) : _selectedColumnDimension;
          _selectedRowDimension.length === 0 ? _selectedRowDimension.push(null) : _selectedRowDimension;

          _selectedMeasure = _sObj.chartMeasures.map(function (_data) {
            return {
              field: { label: _data.numericField, value: _data.numericField },
              type: { label: _data.aggregationType, value: _data.aggregationType }
            };
          });
        } else {
          _selectedMeasure = _sObj.chartMeasures.map(function (_data) {
            return {
              field: { label: _data.numericField, value: _data.numericField },
              type: { label: _data.aggregationType, value: _data.aggregationType }
            };
          });
        }

        _this.setState({
          openModalDialog: _mObj.isOpen,
          modalActionType: _mObj.modalActionType,
          modalChartSettings: _formControls,
          modalHeader: _mObj.modalHeader,
          modalWidth: _mObj.modalWidth,
          modalType: _mObj.modalType,
          selectedModule: _mObj.selectedModule,
          selectedGanttValues: _selectedGanttValues || {},
          widgetCaption: _mObj.widgetCaption,
          selectedApp: {
            label: _sObj.basicChart.appId,
            value: _sObj.basicChart.appId
          },
          selectedTable: {
            label: _sObj.basicChart.resultsetId,
            value: _sObj.basicChart.resultsetId
          },
          selectedColumnDimension: _selectedColumnDimension,
          selectedRowDimension: _selectedRowDimension,
          selectedMeasure: _selectedMeasure,
          selectedFilter: _sObj.basicChart.filters
        });
        if (_sObj.basicChart.dimension) {
          _this.setState({
            selectedDimension: {
              label: _sObj.basicChart.dimension,
              value: _sObj.basicChart.dimension
            }
          });
        } else {
          _this.setState({
            selectedDimension: null
          });
        }
      } else {
        _this.setState({
          openModalDialog: _mObj.isOpen,
          modalHeader: _mObj.modalHeader,
          modalWidth: _mObj.modalWidth,
          modalType: _mObj.modalType,
          selectedModule: _mObj.selectedModule,
          modalActionType: _mObj.modalActionType
        });
      }
    }, _this.refreshWidgetHandler = function (event, _layout) {
      var _widgetsToLoad = [].concat(_toConsumableArray(_this.state.widgetsToLoad)).filter(function (_data) {
        return _data !== _layout.widgetId;
      });
      _this.setState({
        widgetsToLoad: _widgetsToLoad
      });
      setTimeout(function () {
        var _widgetsToLoad1 = [].concat(_toConsumableArray(_this.state.widgetsToLoad));
        _widgetsToLoad1.push(_layout.widgetId);
        _this.setState({
          widgetsToLoad: _widgetsToLoad1
        });
      }, 500);
    }, _this.showNotification = function (res, _type) {

      _this.setState({
        toastOpen: true,
        toastMessage: res.message,
        toastVariant: _type
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(GridLayout, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.updateDimensions();
      window.addEventListener("resize", this.updateDimensions.bind(this));
      if (this.props.widgetDatas && this.props.widgetDatas.layout) {
        this.props.widgetDatas.layout.widgets.map(function (_widget, index) {
          if (_widget.basicChart) {
            if (_widget.basicChart.type.toLowerCase() === "gridtable") {
              _this2.renderGridTableToWidget(_widget);
            } else if (_widget.basicChart.type.toLowerCase() === "pivottable") {
              _this2.renderPivotTableToWidget(_widget);
            } else if (_widget.basicChart.type.toLowerCase() === "tilecard") {
              _this2.renderTileCardToWidget(_widget);
            } else if (_widget.basicChart.type.toLowerCase() === "gantt") {
              _this2.renderChartToWidget(_widget, { "chart": "gantt" });
            } else {
              _this2.renderChartToWidget(_widget);
            }
          }
        });

        var _widgetsToLoad = [];
        var _widgetData = [].concat(_toConsumableArray(this.props.widgetDatas.layout.widgets));
        _widgetData.map(function (_data) {
          _data.isWidgetAdded = true;
          _widgetsToLoad.push(_data.widgetId);
          return _data;
        });

        this.setState({
          layoutData: {
            layout: _widgetData
          },
          widgetsToLoad: _widgetsToLoad
        });
      }
    }
  }, {
    key: 'capitalize',
    value: function capitalize(str) {
      var words = str.trim(); /*&& str.split(/[" ", _ , -]/g).map(_word => {
                              return _word.charAt(0).toUpperCase() + _word.slice(1);
                              });*/
      return words.join(" ");
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _state = this.state,
          layoutData = _state.layoutData,
          toastOpen = _state.toastOpen,
          toastVariant = _state.toastVariant,
          toastMessage = _state.toastMessage,
          openModalDialog = _state.openModalDialog,
          resizeWidget = _state.resizeWidget,
          modalType = _state.modalType,
          modalHeader = _state.modalHeader,
          _state$selectedModule = _state.selectedModule,
          selectedModule = _state$selectedModule === undefined ? {} : _state$selectedModule,
          _state$modalChartSett = _state.modalChartSettings,
          modalChartSettings = _state$modalChartSett === undefined ? {} : _state$modalChartSett,
          modalActionType = _state.modalActionType,
          modalWidth = _state.modalWidth,
          widgetCaption = _state.widgetCaption,
          selectedApp = _state.selectedApp,
          selectedTable = _state.selectedTable,
          dragWidgetId = _state.dragWidgetId,
          selectedDimension = _state.selectedDimension,
          selectedMeasure = _state.selectedMeasure,
          selectedGanttValues = _state.selectedGanttValues,
          _state$selectedRowDim = _state.selectedRowDimension,
          selectedRowDimension = _state$selectedRowDim === undefined ? [] : _state$selectedRowDim,
          _state$selectedColumn = _state.selectedColumnDimension,
          selectedColumnDimension = _state$selectedColumn === undefined ? [] : _state$selectedColumn,
          selectedFilter = _state.selectedFilter,
          selectedWidgetIndex = _state.selectedWidgetIndex,
          resetZIndex = _state.resetZIndex,
          resizeWidgetIndex = _state.resizeWidgetIndex,
          widgetsToLoad = _state.widgetsToLoad;
      var _props = this.props,
          classes = _props.classes,
          _props$currentTabInde = _props.currentTabIndex,
          currentTabIndex = _props$currentTabInde === undefined ? 0 : _props$currentTabInde,
          allowEdit = _props.allowEdit;


      return _react2.default.createElement(
        'div',
        { className: [classes.root, !allowEdit ? classes.marginTop : ""].join(" "), id: 'container' },
        _react2.default.createElement(
          _core.Snackbar,
          {
            anchorOrigin: { vertical: "top", horizontal: "right" },
            open: toastOpen,
            autoHideDuration: 3000,
            onClose: function onClose() {
              _this3.setState({ toastOpen: false });
            }
          },
          _react2.default.createElement(_notifications2.default, {
            variant: toastVariant,
            message: toastMessage,
            onClose: function onClose() {
              _this3.setState({ toastOpen: false });
            }
          })
        ),
        _react2.default.createElement(
          'div',
          { className: 'main-container', style: { position: "relative", width: this.state.totalGridWidth } },
          allowEdit && _react2.default.createElement(
            'table',
            { className: classes.grid },
            this.createTable(classes, currentTabIndex)
          ),
          layoutData && layoutData.layout && layoutData.layout.length ? layoutData.layout.map(function (_layout, _index) {
            return _react2.default.createElement(
              _core.Grid,
              { container: true, spacing: 0,
                key: _layout.widgetId,
                id: _layout.widgetId,
                style: {
                  position: "absolute",
                  zIndex: selectedWidgetIndex === _layout.widgetId && resetZIndex ? 1500 : _layout.widgetId === dragWidgetId ? 500 : _layout.widgetId === resizeWidgetIndex ? 500 : 100,
                  left: Number(_layout.left) + '%',
                  top: Number(_layout.top),
                  right: Number(_layout.right) < 0 ? 0 : Number(_layout.right),
                  height: Number(_layout.height),
                  width: Number(_layout.width) + '%'
                },
                onMouseMove: _this3.handleResizeMouseMove,
                onMouseUp: function onMouseUp(event) {
                  return _this3.handleResizeMouseUp(event, currentTabIndex, _layout.widgetId);
                }
              },
              _react2.default.createElement(
                _reactDraggable2.default,
                {
                  defaultPosition: { x: 0, y: 0 },
                  position: { x: 0, y: 0 },
                  cancel: '.settings-btn',
                  disabled: !allowEdit,
                  scale: 1,
                  bounds: {
                    left: -(Number(_layout.left) * _this3.state.totalGridWidth / 100),
                    top: -Number(_layout.top)
                    // right: ((Number(_layout.right) * this.state.totalGridWidth) / 100),
                    /* bottom: Number(_layout.bottom) */
                  },
                  onStart: function onStart(event) {
                    return _this3.handlerDraggableStartEvent(event, currentTabIndex, _layout.widgetId);
                  },
                  onDrag: function onDrag(event) {
                    return _this3.handlerDraggableDragEvent(event, currentTabIndex, _layout.widgetId);
                  },
                  onStop: function onStop(event) {
                    return _this3.handlerDraggableStopEvent(event, currentTabIndex, _layout.widgetId);
                  }
                },
                _react2.default.createElement(
                  _core.Paper,
                  {
                    className: classes.paper,
                    style: {
                      position: "relative",
                      height: Number(_layout.height) + 55,
                      width: '100%' /* Number(_layout.width) + '%' */
                      , cursor: resizeWidget ? "nwse-resize" : "all-scroll"
                      // fill: bgColor && bgColor 
                    }
                  },
                  allowEdit && _react2.default.createElement(_settingsIcon2.default, {
                    layoutData: layoutData,
                    layout: _layout,
                    removeComponent: _this3.handleRemoveComponent,
                    setSelectedWidgetId: _this3.setSelectedWidgetIdHandler,
                    popoverHandler: _this3.popoverHandler,
                    openModalDialog: _this3.openModalDialogHandler,
                    refreshWidgetData: _this3.refreshWidgetHandler
                  }),
                  _layout.widgetDetails && _layout.widgetDetails.basicChart && !_layout.widgetDetails.basicChart.type.includes("Card") ? _react2.default.createElement(
                    'h4',
                    { style: { textAlign: "center", height: "20px" } },
                    _layout.widgetDetails.basicChart.caption
                  ) : null,
                  _layout && widgetsToLoad.indexOf(_layout.widgetId) !== -1 && _react2.default.createElement(_WidgetContent2.default, { widData: _layout }),
                  allowEdit && _react2.default.createElement(_materialIcons2.default, {
                    icon: 'arrow_forward_ios',
                    className: 'settings-btn',
                    onMouseDown: function onMouseDown(event) {
                      return _this3.handleResizeMouseDown(event, currentTabIndex, _layout.widgetId);
                    },
                    style: {
                      position: "absolute",
                      zIndex: 200,
                      bottom: 0,
                      right: 0,
                      width: 15,
                      transform: "rotate(45deg)",
                      cursor: 'nwse-resize',
                      userSelect: "none"
                    }
                  })
                )
              )
            );
          }) : null
        ),
        openModalDialog && _react2.default.createElement(_modalDiolog2.default, {
          isOpen: openModalDialog,
          closeDialogBox: this.closeDialogBox,
          modalWidth: modalWidth,
          modalType: modalType,
          selectedModule: selectedModule,
          modalHeader: modalHeader,
          formControls: modalChartSettings,
          modalActionType: modalActionType,
          addChartToWidget: this.addChartToWidget,
          widgetCaption: widgetCaption,
          selectedApp: selectedApp,
          selectedTable: selectedTable,
          selectedDimension: selectedDimension,
          selectedMeasure: selectedMeasure,
          selectedGanttValues: selectedGanttValues,
          selectedColumnDimension: selectedColumnDimension,
          selectedRowDimension: selectedRowDimension,
          selectedFilter: selectedFilter
        })
      );
    }
  }]);

  return GridLayout;
}(_react.PureComponent);

exports.default = (0, _core.withStyles)(styles)(GridLayout);