'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _core = require('@material-ui/core');

var _materialIcons = require('./commonComponents/materialIcons');

var _materialIcons2 = _interopRequireDefault(_materialIcons);

var _reactSelect = require('react-select');

var _reactSelect2 = _interopRequireDefault(_reactSelect);

var _genericReactForm = require('generic-react-form');

var _genericReactForm2 = _interopRequireDefault(_genericReactForm);

var _filterAction = require('../actions/filterAction.js');

var _chartSettings = require('../actions/chartSettings');

var _notifications = require('./commonComponents/notifications');

var _notifications2 = _interopRequireDefault(_notifications);

var _expressionFilter = require('./expressionFilter');

var _expressionFilter2 = _interopRequireDefault(_expressionFilter);

var _constants = require('../constants/constants');

require('../styles/dialog.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function Menu(props) {
  return _react2.default.createElement(
    _core.Paper,
    _extends({ square: true, className: 'dropdown-modal' }, props.innerProps),
    props.children
  );
}

var ModalDialogBox = function (_Component) {
  _inherits(ModalDialogBox, _Component);

  function ModalDialogBox() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ModalDialogBox);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ModalDialogBox.__proto__ || Object.getPrototypeOf(ModalDialogBox)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      open: _this.props.isOpen,
      tabId: _this.props.datas && _this.props.datas.tabId,
      datas: _this.props.datas,
      tabName: _this.props.tabName || "",
      tabPosition: _this.props.tabSequence,
      modalType: _this.props.modalType || "tabModal",
      modalWidth: _this.props.modalWidth || "xs",
      modalHeader: _this.props.modalHeader || "",
      modulePackages: _constants._GLOBALMODULEPACKAGES,
      modalActionType: _this.props.modalActionType || "Create",
      selectedGlobalModule: _this.props.selectedModule && _this.props.selectedModule.type && _this.props.selectedModule.type.toLowerCase() || "",
      searchText: "",
      selectedFilter: _this.props.selectedFilter || null,
      selectedApp: _this.props.selectedApp || null,
      selectedTable: _this.props.selectedTable || null,
      selectedDimension: _this.props.selectedDimension || null,
      selectedColumnDimension: _this.props.selectedColumnDimension || [],
      selectedRowDimension: _this.props.selectedRowDimension || [],
      selectedMeasure: _this.props.selectedMeasure || [{ field: null, type: null }],
      applicationList: [],
      selectedGantt: _this.props.selectedGanttValues || {},
      tableList: [],
      dimensionList: [],
      measuresList: [],
      selectedModule: _this.props.selectedModule || {},
      widgetCaption: _this.props.widgetCaption || null,
      chartSettings: {
        controls: _this.props.formControls || [],
        section: true,
        disableSectionHeader: true,
        formButtons: {
          display: false,
          submit: {
            name: 'Submit',
            icon: 'save',
            color: 'primary',
            show: true
          }
        }
      },
      toastOpen: false,
      toastMessage: null,
      toastVariant: null,
      filterSelectionArr: null
    }, _this.handleClose = function () {
      _this.setState({
        open: false,
        tabName: ''
      });
      _this.backToGlobalModuleHandler();
      _this.props.closeDialogBox();
    }, _this.handleSettingModalClose = function () {
      _this.setState({
        open: false,
        modalType: "componentModal",
        modalWidth: "md",
        modalHeader: "Choose component"
      });
      _this.props.closeDialogBox();
    }, _this.handleChange = function (event) {
      _this.setState(_defineProperty({}, event.target.id, event.target.value));
    }, _this.handleCreateUpdate = function (event) {
      var _newTab = {
        layoutId: _this.state.datas.layoutId,
        tabId: _this.state.tabId,
        tabName: _this.state.tabName,
        tabSequence: Number(_this.state.tabPosition)
      };
      _this.props.reCreateTabs(_newTab, _this.state.modalActionType);
      _this.handleClose();
    }, _this.handleRemoveTab = function (event) {

      _this.props.removeTab(event, _this.state.tabId);
    }, _this.handleSearch = function (event) {
      if (event.target.value.trim().length > 0) {
        var _modulePackages = _this.state.modulePackages;
        if (_modulePackages.length === 0) {
          if (selectedGlobalModule === "charts") {
            _modulePackages = _constants._CHARTMODULES;
          } else {
            _modulePackages = _constants._GLOBALMODULEPACKAGES;
          }
        }
        _modulePackages = _modulePackages.filter(function (_data, _ind) {
          return _data.name.toLowerCase().indexOf(event.target.value) > -1;
        });
        _this.setState({
          modulePackages: _modulePackages
        });
      } else {
        if (selectedGlobalModule === "charts") {
          _this.setState({
            modulePackages: _constants._CHARTMODULES
          });
        } else {
          _this.setState({
            modulePackages: _constants._GLOBALMODULEPACKAGES,
            selectedGlobalModule: ""
          });
        }
      }
      _this.setState({
        searchText: event.target.value
      });
    }, _this.handleEmptySearch = function (event) {
      if (selectedGlobalModule === "charts") {
        _this.setState({
          searchText: "",
          modulePackages: _constants._CHARTMODULES
        });
      } else {
        _this.backToGlobalModuleHandler();
      }
    }, _this.loadSettingsModal = function (event, _data) {
      _this.clearAllSelections();
      switch (_data.type.toLowerCase()) {
        case "charts":
          _this.setState({
            selectedGlobalModule: _data.type.toLowerCase(),
            modulePackages: _constants._CHARTMODULES
          });
          break;
        case "gantt":
          _this.setState({
            selectedMeasure: null
          });
          _this.loadSettingItems(_data.module, _data);
          break;
        case "gridtable":
          _this.setState({
            selectedGlobalModule: _data.type.toLowerCase()
          });
          _this.loadSettingItems(_data.module, _data);
          break;
        case "pivottable":
          _this.setState({
            selectedGlobalModule: _data.type.toLowerCase(),
            selectedColumnDimension: [null],
            selectedRowDimension: [null]
          });
          _this.loadSettingItems(_data.module, _data);
          break;
        case "tilecard":
          _this.setState({
            selectedGlobalModule: _data.type.toLowerCase()
          });
          _this.loadSettingItems(_data.module, _data);
          break;
        default:
          _this.loadSettingItems(_data.module, _data);
          break;
      }
    }, _this.loadSettingItems = function (_request, _data) {
      (0, _chartSettings.getChartSettings)(_request).then(function (res) {
        if (res.error) {
          _this.showNotification(res, "error");
        } else {
          res.map(function (_valObj, index) {
            _valObj.label = _valObj.comment;
            if (index <= res.length / 2) _valObj.section = '1';else _valObj.section = '2';
            return _valObj;
          });
          _this.setState({
            searchText: "",
            modalWidth: "sm",
            modalType: "settingsModal",
            selectedModule: _data,
            chartSettings: _extends({}, _this.state.chartSettings, {
              section: true,
              disableSectionHeader: true,
              controls: res
            }),
            modalHeader: "Settings"
          });
        }
      }).catch(function (err) {
        _this.showNotification(err, "error");
      });
    }, _this.handleChangeTable = function (name, type) {
      return function (_value) {
        _this.setState(_defineProperty({}, name, _value));
        if (type === "app" || type === "table") {
          _this.loadDropDownData(type, _value.value);
        } else if (type === "dimension-col" || type === "dimension-row") {
          _this.pivotDimensionHandler(name, type, _value);
        } else {
          if (name !== "selectedDimension") {
            _this.measureAndTypehandler(name, type, _value);
          }
        }
      };
    }, _this.pivotDimensionHandler = function (_index, type, _value) {
      if (type === "dimension-col") {
        var _selectedColumnDimension = [].concat(_toConsumableArray(_this.state.selectedColumnDimension));
        _selectedColumnDimension.splice(_index, 1, _value);
        _this.setState({
          selectedColumnDimension: _selectedColumnDimension
        });
      } else {
        var _selectedRowDimension = [].concat(_toConsumableArray(_this.state.selectedRowDimension));
        _selectedRowDimension.splice(_index, 1, _value);
        _this.setState({
          selectedRowDimension: _selectedRowDimension
        });
      }
    }, _this.measureAndTypehandler = function (_index, type, _value) {
      if (type === "measure") {
        var _selectedMeasure = [].concat(_toConsumableArray(_this.state.selectedMeasure));
        _selectedMeasure[_index]["field"] = _value;
        _this.setState({
          selectedMeasure: _selectedMeasure
        });
      } else {
        var _selectedMeasure2 = [].concat(_toConsumableArray(_this.state.selectedMeasure));
        _selectedMeasure2[_index]["type"] = _value;
        _this.setState({
          selectedMeasure: _selectedMeasure2
        });
      }
    }, _this.loadDropDownData = function (type, value) {
      if (type === "app") {
        var _request = {
          "appId": "PRISM",
          "filterId": "resultset_meta_filter",
          "filters": [{
            "field": "app_id",
            "operator": "Equals",
            "value": [value]
          }, {
            "field": "name",
            "operator": "Contains",
            "value": [""]
          }]
        };
        (0, _filterAction.getFilterFields)(_request).then(function (res) {
          if (res.error) {
            _this.showNotification(res, "error");
          } else {
            res.map(function (item) {
              item.label = item.id;
              item.value = item.id;
              return item;
            });
            _this.setState({
              tableList: res
            });
          }
        }).catch(function (err) {
          _this.showNotification(err, "error");
        });
      }
      if (type === "table") {
        var _request2 = {
          "appId": "PRISM",
          "filterId": "resultset_meta_columns_filter",
          "filters": [{
            "field": "app_id",
            "operator": "Equals",
            "value": [_this.state.selectedApp.value]
          }, {
            "field": "fieldname",
            "operator": "Contains",
            "value": [""]
          }, {
            "field": "table_id",
            "operator": "Equals",
            "value": [value]
          }]
        };
        (0, _filterAction.getFilterFields)(_request2).then(function (res) {
          if (res.error) {
            _this.showNotification(res, "error");
          } else {
            res.map(function (item) {
              item.label = item.fieldname;
              item.value = item.fieldname;
            });
            _this.setState({
              dimensionList: res,
              measuresList: res
            });
          }
        }).catch(function (err) {
          _this.showNotification(err, "error");
        });
      }
    }, _this.handleFormSubmit = function (event, _formData) {
      var _actionType = _this.state.modalActionType;
      var _data = _formData;
      _data["selectedApp"] = _this.state.selectedApp;
      _data["selectedTable"] = _this.state.selectedTable;
      _data["selectedDimension"] = _this.state.selectedDimension;
      _data["selectedMeasure"] = _this.state.selectedMeasure;
      _data["selectedColumnDimension"] = _this.state.selectedColumnDimension;
      _data["selectedRowDimension"] = _this.state.selectedRowDimension;
      _data["selectedGanttValues"] = _this.state.selectedGantt;
      _data["selectedFilter"] = _this.state.filterSelectionArr;
      _data["caption"] = _this.state.widgetCaption;
      _this.props.addChartToWidget(_data, _this.state.selectedModule, _this.state.chartSettings, _actionType); //chartDatas[this.state.selectedModule.type + "Data"]
    }, _this.applySettings = function (event) {
      if (document.getElementById("submitButton")) {
        document.getElementById("submitButton").click();
      } else {
        _this.handleFormSubmit(event, {});
      }
      _this.handleSettingModalClose();
    }, _this.changeModuleHandler = function (event) {
      _this.setState({
        open: true,
        modalWidth: "md",
        modalType: "componentModal",
        modalHeader: "Choose component"
      });
      _this.clearAllSelections();
    }, _this.clearAllSelections = function () {
      _this.setState({
        selectedGlobalModule: null,
        searchText: "",
        selectedApp: null,
        selectedTable: null,
        selectedDimension: null,
        selectedColumnDimension: [],
        selectedRowDimension: [],
        selectedMeasure: [{ field: null, type: null }],
        selectedModule: {},
        widgetCaption: null,
        selectedGantt: {},
        selectedFilter: null
      });
    }, _this.backToGlobalModuleHandler = function (event) {
      _this.setState({
        searchText: "",
        modulePackages: _constants._GLOBALMODULEPACKAGES,
        selectedGlobalModule: ""
      });
    }, _this.showNotification = function (res, _type) {
      _this.setState({
        toastOpen: true,
        toastMessage: res.message,
        toastVariant: _type
      });
    }, _this.addMoreMeasureHandler = function (event) {
      var _selectedMeasure = [].concat(_toConsumableArray(_this.state.selectedMeasure));
      var _newMeasure = { field: null, type: null };
      _selectedMeasure.push(_newMeasure);
      _this.setState({
        selectedMeasure: _selectedMeasure
      });
    }, _this.removeMeasureHnadler = function (event, _deleteMeasure, _index) {
      var _selectedMeasure = [].concat(_toConsumableArray(_this.state.selectedMeasure));
      _selectedMeasure.splice(_index, 1);
      _this.setState({
        selectedMeasure: _selectedMeasure
      });
    }, _this.addMoreColumnDimensionHandler = function (event) {
      var _selectedColumnDimension = [].concat(_toConsumableArray(_this.state.selectedColumnDimension));
      _selectedColumnDimension.push(null);
      _this.setState({
        selectedColumnDimension: _selectedColumnDimension
      });
    }, _this.removeColumnDimensionHnadler = function (event, _deleteMeasure, _index) {
      var _selectedColumnDimension = [].concat(_toConsumableArray(_this.state.selectedColumnDimension));
      _selectedColumnDimension.splice(_index, 1);
      _this.setState({
        selectedColumnDimension: _selectedColumnDimension
      });
    }, _this.addMoreRowDimensionHandler = function (event) {
      var _selectedRowDimension = [].concat(_toConsumableArray(_this.state.selectedRowDimension));
      _selectedRowDimension.push(null);
      _this.setState({
        selectedRowDimension: _selectedRowDimension
      });
    }, _this.removeRowDimensionHnadler = function (event, _deleteMeasure, _index) {
      var _selectedRowDimension = [].concat(_toConsumableArray(_this.state.selectedRowDimension));
      _selectedRowDimension.splice(_index, 1);
      _this.setState({
        selectedRowDimension: _selectedRowDimension
      });
    }, _this.handleGanttChartSelection = function (attr) {
      return function (_value) {
        _this.setState({
          selectedGantt: _extends({}, _this.state.selectedGantt, _defineProperty({}, attr, { label: _value.label, value: _value.label }))
        });
      };
    }, _this.handleFilterValue = function (_val) {
      var _filters = _val;
      /* try {
        _filters = _val.join("");
      } catch (err) {
        _filters = "";
      } */
      _this.setState({
        filterSelectionArr: _filters
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ModalDialogBox, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var _request = {
        "appId": "PRISM",
        "filterId": "app_filter",
        "q": ""
      };
      (0, _filterAction.getFilterFields)(_request).then(function (res) {
        if (res.error) {
          _this2.showNotification(res, "error");
        } else {
          _this2.setState({
            applicationList: res
          });
        }
      }).catch(function (err) {
        _this2.showNotification(err, "error");
      });

      if (this.props.modalType === "settingsModal") {
        this.loadDropDownData("app", this.props.selectedApp.value);
        this.loadDropDownData("table", this.props.selectedTable.value);
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(props) {
      this.setState({
        searchText: "",
        open: props.isOpen,
        datas: props.datas,
        tabId: props.datas && props.datas.tabId,
        tabName: props.tabName,
        tabPosition: props.tabSequence,
        modalActionType: props.modalActionType
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var components = { Menu: Menu };
      var _state = this.state,
          modulePackages = _state.modulePackages,
          searchText = _state.searchText,
          modalType = _state.modalType,
          modalWidth = _state.modalWidth,
          modalHeader = _state.modalHeader,
          modalActionType = _state.modalActionType,
          applicationList = _state.applicationList,
          tableList = _state.tableList,
          dimensionList = _state.dimensionList,
          measuresList = _state.measuresList,
          chartSettings = _state.chartSettings,
          selectedModule = _state.selectedModule,
          selectedApp = _state.selectedApp,
          selectedTable = _state.selectedTable,
          selectedDimension = _state.selectedDimension,
          selectedMeasure = _state.selectedMeasure,
          selectedFilter = _state.selectedFilter,
          toastOpen = _state.toastOpen,
          toastVariant = _state.toastVariant,
          toastMessage = _state.toastMessage,
          tabName = _state.tabName,
          tabPosition = _state.tabPosition,
          widgetCaption = _state.widgetCaption,
          selectedRowDimension = _state.selectedRowDimension,
          selectedColumnDimension = _state.selectedColumnDimension,
          selectedGantt = _state.selectedGantt,
          selectedGlobalModule = _state.selectedGlobalModule;
      var tabCounts = this.props.tabCounts;

      var settingsToCompBtn = "Apply";
      if (modalType === "settingsModal") {
        if (modalActionType && modalActionType.toLowerCase() === "update") {
          settingsToCompBtn = "Change Module";
        } else {
          settingsToCompBtn = "Back";
        }
      }

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          _core.Snackbar,
          {
            anchorOrigin: { vertical: "top", horizontal: "right" },
            open: toastOpen,
            autoHideDuration: 3000,
            onClose: function onClose(event) {
              _this3.setState({ toastOpen: false });
            }
          },
          _react2.default.createElement(_notifications2.default, {
            variant: toastVariant,
            message: toastMessage,
            onClose: function onClose(event) {
              _this3.setState({ toastOpen: false });
            }
          })
        ),
        _react2.default.createElement(
          _core.Dialog,
          {
            className: "main-dialog",
            maxWidth: modalWidth,
            scroll: 'body',
            open: this.state.open,
            disableBackdropClick: true,
            disableEscapeKeyDown: true,
            transitionDuration: 500,
            'aria-labelledby': 'form-dialog-title'
          },
          _react2.default.createElement(
            _core.DialogTitle,
            { className: 'form-dialog-title', id: 'form-dialog-title' },
            modalType === "settingsModal" ? selectedModule.name + " " + modalHeader : modalHeader || (modalActionType && modalActionType.toLowerCase() === 'update' ? "Edit tab" : "Add new tab"),
            modalType === "settingsModal" && _react2.default.createElement(
              'div',
              { className: 'display-flex' },
              _react2.default.createElement(
                _core.Button,
                { color: 'primary', className: 'btn-capitalize',
                  onClick: function onClick(event) {
                    return _this3.changeModuleHandler(event, settingsToCompBtn);
                  }
                },
                settingsToCompBtn
              )
            )
          ),
          _react2.default.createElement(_core.Divider, { varient: 'middle' }),
          _react2.default.createElement(
            _core.DialogContent,
            { className: 'dialog-body' },
            modalType === "tabModal" && _react2.default.createElement(
              'div',
              { className: 'tab-container' },
              _react2.default.createElement(_core.TextField, {
                autoFocus: true,
                id: 'tabName',
                label: 'Name',
                type: 'email',
                value: tabName,
                variant: 'outlined',
                className: 'text-field btn-mgnTB',
                onChange: this.handleChange
              }),
              _react2.default.createElement(_core.TextField, {
                id: 'tabPosition',
                label: 'Position',
                value: tabPosition,
                type: 'number',
                variant: 'outlined',
                className: 'text-field btn-mgnTB',
                onChange: this.handleChange
              }),
              _react2.default.createElement(
                'div',
                null,
                tabCounts > 1 && modalActionType && modalActionType.toLowerCase() === 'update' ? _react2.default.createElement(
                  _core.Button,
                  { color: 'secondary', className: 'btn-mgnTB btn-capitalize', onClick: this.handleRemoveTab },
                  'Remove Tab'
                ) : null
              )
            ),
            modalType === "componentModal" && _react2.default.createElement(
              'div',
              { className: 'component-container' },
              _react2.default.createElement(_core.TextField, {
                className: 'search-field-component',
                variant: 'outlined',
                label: "Choose component",
                InputLabelProps: { shrink: true },
                value: searchText,
                onChange: this.handleSearch,
                InputProps: {
                  endAdornment: _react2.default.createElement(
                    _core.InputAdornment,
                    { position: 'end' },
                    searchText.length === 0 && _react2.default.createElement(
                      _core.IconButton,
                      null,
                      _react2.default.createElement(_materialIcons2.default, { icon: 'search' })
                    ),
                    searchText.length > 0 && _react2.default.createElement(
                      _core.IconButton,
                      { onClick: this.handleEmptySearch },
                      _react2.default.createElement(_materialIcons2.default, { icon: 'clear' })
                    )
                  )
                },
                margin: 'normal' }),
              _react2.default.createElement(
                'div',
                { className: 'package-header' },
                _react2.default.createElement(
                  'p',
                  { className: 'header-name' },
                  'Packages'
                ),
                selectedGlobalModule === "charts" && _react2.default.createElement(
                  _core.Button,
                  { className: 'back-btn btn-capitalize', onClick: this.backToGlobalModuleHandler, color: 'primary' },
                  'Back'
                )
              ),
              _react2.default.createElement(_core.Divider, { className: 'divider' }),
              _react2.default.createElement(
                'div',
                { className: 'card-container' },
                modulePackages.map(function (_type, _index) {
                  return _react2.default.createElement(
                    _core.Card,
                    { key: "card-" + _index, className: 'ripple card',
                      onClick: function onClick(event) {
                        return _this3.loadSettingsModal(event, _type);
                      } },
                    _react2.default.createElement(
                      _core.CardContent,
                      { className: 'card-content' },
                      _react2.default.createElement(
                        'div',
                        { className: 'd-inline chart-icon' },
                        _react2.default.createElement(_materialIcons2.default, { icon: _type.icon })
                      ),
                      _react2.default.createElement(
                        'p',
                        { className: 'd-inline chart-name' },
                        _type.name
                      )
                    )
                  );
                })
              )
            ),
            modalType === "settingsModal" && _react2.default.createElement(
              'div',
              { className: 'settings-container' },
              _react2.default.createElement(_core.TextField, {
                id: 'widgetCaption',
                label: 'Enter widget title',
                variant: 'outlined',
                InputLabelProps: { shrink: true },
                value: widgetCaption,
                className: 'widget-text-field',
                onChange: this.handleChange
              }),
              _react2.default.createElement(
                _core.NoSsr,
                null,
                _react2.default.createElement(_reactSelect2.default, {
                  className: 'dropdown-box',
                  options: applicationList,
                  value: selectedApp,
                  placeholder: 'Select application',
                  components: components,
                  onChange: this.handleChangeTable('selectedApp', 'app'),
                  isClearable: true
                })
              ),
              _react2.default.createElement(
                _core.NoSsr,
                null,
                _react2.default.createElement(_reactSelect2.default, {
                  className: 'dropdown-box',
                  options: tableList,
                  value: selectedTable,
                  placeholder: 'Select table',
                  components: components,
                  onChange: this.handleChangeTable('selectedTable', 'table'),
                  isClearable: true
                })
              ),
              selectedGlobalModule !== "gridtable" && selectedModule && selectedModule.type !== "Gantt" && _react2.default.createElement(
                'div',
                null,
                selectedGlobalModule !== "pivottable" && selectedGlobalModule !== "tilecard" && selectedModule && selectedModule.type.toLowerCase() !== "gauge" && _react2.default.createElement(
                  _core.NoSsr,
                  null,
                  _react2.default.createElement(_reactSelect2.default, {
                    className: 'dropdown-box',
                    options: dimensionList,
                    value: selectedDimension,
                    placeholder: 'Choose dimension',
                    components: components,
                    onChange: this.handleChangeTable('selectedDimension', 'dimension'),
                    isClearable: true
                  })
                ),
                selectedGlobalModule === "pivottable" && selectedGlobalModule !== "tilecard" && selectedColumnDimension.map(function (_item, _index) {
                  return _react2.default.createElement(
                    'div',
                    { key: "measure-" + _index, className: 'dimension-container' },
                    _react2.default.createElement(
                      'div',
                      { className: 'dimension-div' },
                      _react2.default.createElement(
                        _core.NoSsr,
                        null,
                        _react2.default.createElement(_reactSelect2.default, {
                          className: 'dropdown-box',
                          options: dimensionList,
                          value: _item,
                          placeholder: 'Choose column dimension',
                          components: components,
                          onChange: _this3.handleChangeTable(_index, 'dimension-col'),
                          isClearable: true
                        })
                      )
                    ),
                    _react2.default.createElement(
                      'div',
                      { className: 'dimension-add-delete' },
                      selectedColumnDimension.length > 1 && _react2.default.createElement(
                        _core.Tooltip,
                        { title: 'Remove', 'aria-label': 'Remove' },
                        _react2.default.createElement(
                          _core.IconButton,
                          { color: 'secondary', className: 'delete-btn',
                            onClick: function onClick(event) {
                              return _this3.removeColumnDimensionHnadler(event, _item, _index);
                            }
                          },
                          _react2.default.createElement(_materialIcons2.default, { icon: 'delete' })
                        )
                      ),
                      selectedColumnDimension.length - 1 === _index && _react2.default.createElement(
                        _core.Tooltip,
                        { title: 'Add', 'aria-label': 'Add' },
                        _react2.default.createElement(
                          _core.IconButton,
                          { color: 'primary', className: 'add-btn',
                            onClick: _this3.addMoreColumnDimensionHandler
                          },
                          _react2.default.createElement(_materialIcons2.default, { icon: 'add_box' })
                        )
                      )
                    )
                  );
                }),
                selectedGlobalModule === "pivottable" && selectedGlobalModule !== "tilecard" && selectedRowDimension.map(function (_item, _index) {
                  return _react2.default.createElement(
                    'div',
                    { key: "measure-" + _index, className: 'dimension-container' },
                    _react2.default.createElement(
                      'div',
                      { className: 'dimension-div' },
                      _react2.default.createElement(
                        _core.NoSsr,
                        null,
                        _react2.default.createElement(_reactSelect2.default, {
                          className: 'dropdown-box',
                          options: dimensionList,
                          value: _item,
                          placeholder: 'Choose row dimension',
                          components: components,
                          onChange: _this3.handleChangeTable(_index, 'dimension-row'),
                          isClearable: true
                        })
                      )
                    ),
                    _react2.default.createElement(
                      'div',
                      { className: 'dimension-add-delete' },
                      selectedRowDimension.length > 1 && _react2.default.createElement(
                        _core.Tooltip,
                        { title: 'Remove', 'aria-label': 'Remove' },
                        _react2.default.createElement(
                          _core.IconButton,
                          { color: 'secondary', className: 'delete-btn',
                            onClick: function onClick(event) {
                              return _this3.removeRowDimensionHnadler(event, _item, _index);
                            }
                          },
                          _react2.default.createElement(_materialIcons2.default, { icon: 'delete' })
                        )
                      ),
                      selectedRowDimension.length - 1 === _index && _react2.default.createElement(
                        _core.Tooltip,
                        { title: 'Add', 'aria-label': 'Add' },
                        _react2.default.createElement(
                          _core.IconButton,
                          { color: 'primary', className: 'add-btn',
                            onClick: _this3.addMoreRowDimensionHandler
                          },
                          _react2.default.createElement(_materialIcons2.default, { icon: 'add_box' })
                        )
                      )
                    )
                  );
                }),
                selectedMeasure.map(function (_item, _index) {
                  return _react2.default.createElement(
                    'div',
                    { key: "measure-" + _index, className: 'measure-container' },
                    _react2.default.createElement(
                      'div',
                      { className: 'measure-measure',
                        style: {
                          width: selectedGlobalModule === "tilecard" || selectedGlobalModule === "pivottable" ? "49%" : "40%"
                        } },
                      _react2.default.createElement(_reactSelect2.default, {
                        className: 'dropdown-box',
                        options: measuresList,
                        value: _item.field,
                        placeholder: 'Choose measure',
                        components: components,
                        onChange: _this3.handleChangeTable(_index, 'measure'),
                        isClearable: true
                      })
                    ),
                    _react2.default.createElement(
                      'div',
                      { className: 'measure-type',
                        style: {
                          width: selectedGlobalModule === "tilecard" || selectedGlobalModule === "pivottable" ? "49%" : "40%"
                        } },
                      _react2.default.createElement(_reactSelect2.default, {
                        className: 'dropdown-box',
                        options: _constants._MEASURESTYPELIST,
                        value: _item.type,
                        placeholder: 'Choose measure type',
                        components: components,
                        onChange: _this3.handleChangeTable(_index, 'measureType'),
                        isClearable: true
                      })
                    ),
                    _react2.default.createElement(
                      'div',
                      { className: 'measure-add-delete' },
                      selectedMeasure.length > 1 && _react2.default.createElement(
                        _core.Tooltip,
                        { title: 'Remove', 'aria-label': 'Remove' },
                        _react2.default.createElement(
                          _core.IconButton,
                          { color: 'secondary', className: 'delete-btn',
                            onClick: function onClick(event) {
                              return _this3.removeMeasureHnadler(event, _item, _index);
                            }
                          },
                          _react2.default.createElement(_materialIcons2.default, { icon: 'delete' })
                        )
                      ),
                      selectedMeasure.length - 1 === _index && selectedGlobalModule !== "tilecard" && selectedGlobalModule !== "pivottable" && _react2.default.createElement(
                        _core.Tooltip,
                        { title: 'Add', 'aria-label': 'Add' },
                        _react2.default.createElement(
                          _core.IconButton,
                          { color: 'primary', className: 'add-btn',
                            onClick: _this3.addMoreMeasureHandler
                          },
                          _react2.default.createElement(_materialIcons2.default, { icon: 'add_box' })
                        )
                      )
                    )
                  );
                })
              ),
              selectedModule && selectedModule.type == "Gantt" && _react2.default.createElement(
                'div',
                { className: 'gantt-chart-container' },
                _react2.default.createElement(
                  'div',
                  { className: 'gantt-dimension-div marginRT5' },
                  _react2.default.createElement(
                    _core.NoSsr,
                    null,
                    _react2.default.createElement(_reactSelect2.default, {
                      className: 'dropdown-box',
                      options: dimensionList,
                      value: selectedGantt['task_id'],
                      placeholder: 'Choose task id',
                      components: components,
                      onChange: this.handleGanttChartSelection('task_id'),
                      isClearable: true
                    })
                  )
                ),
                _react2.default.createElement(
                  'div',
                  { className: 'gantt-dimension-div' },
                  _react2.default.createElement(
                    _core.NoSsr,
                    null,
                    _react2.default.createElement(_reactSelect2.default, {
                      className: 'dropdown-box',
                      options: dimensionList,
                      value: selectedGantt['task_name'],
                      placeholder: 'Choose task name',
                      components: components,
                      onChange: this.handleGanttChartSelection('task_name'),
                      isClearable: true
                    })
                  )
                ),
                _react2.default.createElement(
                  'div',
                  { className: 'gantt-dimension-div marginRT5' },
                  _react2.default.createElement(
                    _core.NoSsr,
                    null,
                    _react2.default.createElement(_reactSelect2.default, {
                      className: 'dropdown-box',
                      options: dimensionList,
                      value: selectedGantt['start_date'],
                      placeholder: 'Choose start date',
                      components: components,
                      onChange: this.handleGanttChartSelection('start_date'),
                      isClearable: true
                    })
                  )
                ),
                _react2.default.createElement(
                  'div',
                  { className: 'gantt-dimension-div' },
                  _react2.default.createElement(
                    _core.NoSsr,
                    null,
                    _react2.default.createElement(_reactSelect2.default, {
                      className: 'dropdown-box',
                      options: dimensionList,
                      value: selectedGantt['end_date'],
                      placeholder: 'Choose end date',
                      components: components,
                      onChange: this.handleGanttChartSelection('end_date'),
                      isClearable: true
                    })
                  )
                ),
                _react2.default.createElement(
                  'div',
                  { className: 'gantt-dimension-div marginRT5' },
                  _react2.default.createElement(
                    _core.NoSsr,
                    null,
                    _react2.default.createElement(_reactSelect2.default, {
                      className: 'dropdown-box',
                      options: dimensionList,
                      value: selectedGantt['duration'],
                      placeholder: 'Choose duration',
                      components: components,
                      onChange: this.handleGanttChartSelection('duration'),
                      isClearable: true
                    })
                  )
                ),
                _react2.default.createElement(
                  'div',
                  { className: 'gantt-dimension-div' },
                  _react2.default.createElement(
                    _core.NoSsr,
                    null,
                    _react2.default.createElement(_reactSelect2.default, {
                      className: 'dropdown-box',
                      options: dimensionList,
                      value: selectedGantt['percent_complete'],
                      placeholder: 'Choose percentage complete',
                      components: components,
                      onChange: this.handleGanttChartSelection('percent_complete'),
                      isClearable: true
                    })
                  )
                ),
                _react2.default.createElement(
                  'div',
                  { className: 'gantt-measure-div' },
                  _react2.default.createElement(
                    _core.NoSsr,
                    null,
                    _react2.default.createElement(_reactSelect2.default, {
                      className: 'dropdown-box',
                      options: dimensionList,
                      value: selectedGantt['dependencies'],
                      placeholder: 'Choose dependencies',
                      components: components,
                      onChange: this.handleGanttChartSelection('dependencies'),
                      isClearable: true
                    })
                  )
                )
              ),
              _react2.default.createElement(_expressionFilter2.default, {
                selectedFilter: selectedFilter,
                selectedApp: selectedApp,
                selectedTable: selectedTable,
                setFilterValue: this.handleFilterValue
              }),
              chartSettings.controls.length && _react2.default.createElement(_genericReactForm2.default, { FormData: chartSettings, formSubmit2: this.handleFormSubmit })
            )
          ),
          _react2.default.createElement(
            _core.DialogActions,
            { className: 'dialog-footer', style: { marginTop: modalType === "settingsModal" ? -30 : 0 } },
            modalType === "tabModal" && _react2.default.createElement(
              'div',
              null,
              _react2.default.createElement(
                _core.Button,
                { className: 'btn-capitalize', onClick: this.handleClose, color: 'primary' },
                'Close'
              ),
              _react2.default.createElement(
                _core.Button,
                { className: 'btn-capitalize', onClick: this.handleCreateUpdate, color: 'primary' },
                modalActionType
              )
            ),
            modalType === "componentModal" && _react2.default.createElement(
              _core.Button,
              { className: 'btn-capitalize', onClick: this.handleClose, color: 'primary' },
              'Close'
            ),
            modalType === "settingsModal" && _react2.default.createElement(
              'div',
              null,
              _react2.default.createElement(
                _core.Button,
                { className: 'btn-capitalize', onClick: this.handleSettingModalClose, color: 'primary' },
                'Close'
              ),
              _react2.default.createElement(
                _core.Button,
                { className: 'btn-capitalize', onClick: this.applySettings, color: 'primary' },
                modalActionType
              )
            )
          )
        )
      );
    }
  }]);

  return ModalDialogBox;
}(_react.Component);

exports.default = ModalDialogBox;