'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

require('@material-ui/core');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ComponentModal = function (_Component) {
  _inherits(ComponentModal, _Component);

  function ComponentModal() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ComponentModal);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ComponentModal.__proto__ || Object.getPrototypeOf(ComponentModal)).call.apply(_ref, [this].concat(args))), _this), _this.handleEmptySearch = function (event) {
      if (_this.state.selectedGlobalModule === "charts") {
        _this.setState({
          searchText: "",
          modulePackages: _CHARTMODULES
        });
      } else {
        _this.backToGlobalModuleHandler();
      }
    }, _this.backToGlobalModuleHandler = function (event) {
      _this.setState({
        searchText: "",
        modulePackages: _GLOBALMODULEPACKAGES,
        selectedGlobalModule: ""
      });
    }, _this.handleSearch = function (event) {
      if (event.target.value.trim().length > 0) {
        var _modulePackages = _this.state.modulePackages;
        if (_modulePackages.length === 0) {
          if (_this.state.selectedGlobalModule === "charts") {
            _modulePackages = _CHARTMODULES;
          } else {
            _modulePackages = _GLOBALMODULEPACKAGES;
          }
        }
        _modulePackages = _modulePackages.filter(function (_data, _ind) {
          return _data.name.toLowerCase().indexOf(event.target.value) > -1;
        });
        _this.setState({
          modulePackages: _modulePackages
        });
      } else {
        if (_this.state.selectedGlobalModule === "charts") {
          _this.setState({
            modulePackages: _CHARTMODULES
          });
        } else {
          _this.setState({
            modulePackages: _GLOBALMODULEPACKAGES,
            selectedGlobalModule: ""
          });
        }
      }
      _this.setState({
        searchText: event.target.value
      });
    }, _this.handleClose = function () {
      _this.setState({
        open: false,
        tabName: ''
      });
      _this.backToGlobalModuleHandler();
      _this.props.closeDialogBox();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ComponentModal, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement(
        Dialog,
        {
          className: "main-dialog",
          maxWidth: modalWidth,
          scroll: 'body',
          open: this.state.open,
          disableBackdropClick: true,
          disableEscapeKeyDown: true,
          transitionDuration: 500,
          'aria-labelledby': 'form-dialog-title'
        },
        _react2.default.createElement(
          DialogTitle,
          { className: 'form-dialog-title', id: 'form-dialog-title' },
          modalHeader
        ),
        _react2.default.createElement(Divider, { varient: 'middle' }),
        _react2.default.createElement(
          DialogContent,
          { className: 'dialog-body' },
          _react2.default.createElement(
            'div',
            { className: 'component-container' },
            _react2.default.createElement(TextField, {
              className: 'search-field-component',
              variant: 'outlined',
              label: "Choose component",
              InputLabelProps: { shrink: true },
              value: searchText,
              onChange: this.handleSearch,
              InputProps: {
                endAdornment: _react2.default.createElement(
                  InputAdornment,
                  { position: 'end' },
                  searchText.length === 0 && _react2.default.createElement(
                    IconButton,
                    null,
                    _react2.default.createElement(MaterialIcon, { icon: 'search' })
                  ),
                  searchText.length > 0 && _react2.default.createElement(
                    IconButton,
                    { onClick: this.handleEmptySearch },
                    _react2.default.createElement(MaterialIcon, { icon: 'clear' })
                  )
                )
              },
              margin: 'normal' }),
            _react2.default.createElement(
              'div',
              { className: 'package-header' },
              _react2.default.createElement(
                'p',
                { className: 'header-name' },
                'Packages'
              ),
              this.state.selectedGlobalModule === "charts" && _react2.default.createElement(
                Button,
                { className: 'back-btn btn-capitalize', onClick: this.backToGlobalModuleHandler, color: 'primary' },
                'Back'
              )
            ),
            _react2.default.createElement(Divider, { className: 'divider' }),
            _react2.default.createElement(
              'div',
              { className: 'card-container' },
              modulePackages.map(function (_type, _index) {
                return _react2.default.createElement(
                  Card,
                  { key: "card-" + _index, className: 'ripple card',
                    onClick: function onClick(event) {
                      return _this2.loadSettingsModal(event, _type);
                    } },
                  _react2.default.createElement(
                    CardContent,
                    { className: 'card-content' },
                    _react2.default.createElement(
                      'div',
                      { className: 'd-inline chart-icon' },
                      _react2.default.createElement(MaterialIcon, { icon: _type.icon })
                    ),
                    _react2.default.createElement(
                      'p',
                      { className: 'd-inline chart-name' },
                      _type.name
                    )
                  )
                );
              })
            )
          )
        ),
        _react2.default.createElement(
          DialogActions,
          { className: 'dialog-footer' },
          _react2.default.createElement(
            Button,
            { className: 'btn-capitalize', onClick: this.handleClose, color: 'primary' },
            'Close'
          )
        )
      );
    }
  }]);

  return ComponentModal;
}(_react.Component);

exports.default = ComponentModal;