'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _core = require('@material-ui/core');

require('../../styles/dialog.scss');

require('../../styles/style.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ConfirmationModal = function (_Component) {
  _inherits(ConfirmationModal, _Component);

  function ConfirmationModal() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ConfirmationModal);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ConfirmationModal.__proto__ || Object.getPrototypeOf(ConfirmationModal)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      open: _this.props.openModal || false
    }, _this.yesActionHandler = function (event) {
      _this.props.confirmHandler("yes");
    }, _this.noActionHandler = function (event) {
      _this.props.confirmHandler("no");
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ConfirmationModal, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          modalWidth = _props.modalWidth,
          modalHeader = _props.modalHeader,
          yesAction = _props.yesAction,
          noAction = _props.noAction,
          modalContent = _props.modalContent;

      return _react2.default.createElement(
        _core.Dialog,
        {
          className: "confirmation-dialog",
          maxWidth: modalWidth,
          scroll: 'body',
          open: this.state.open,
          disableBackdropClick: true,
          disableEscapeKeyDown: true,
          transitionDuration: 500,
          'aria-labelledby': 'form-dialog-title'
        },
        _react2.default.createElement(
          _core.DialogTitle,
          { className: 'confirmation-dialog-title', id: 'form-dialog-title' },
          modalHeader
        ),
        _react2.default.createElement(_core.Divider, { varient: 'middle' }),
        _react2.default.createElement(
          _core.DialogContent,
          { className: 'confirmation-dialog-body' },
          modalContent
        ),
        _react2.default.createElement(
          _core.DialogActions,
          { className: 'confirmation-dialog-footer' },
          _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(
              _core.Button,
              { className: 'btn-capitalize', onClick: this.yesActionHandler, color: 'primary' },
              yesAction
            ),
            _react2.default.createElement(
              _core.Button,
              { className: 'btn-capitalize', onClick: this.noActionHandler, color: 'primary' },
              noAction
            )
          )
        )
      );
    }
  }]);

  return ConfirmationModal;
}(_react.Component);

exports.default = ConfirmationModal;