'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

require('@material-ui/core');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SettingsModal = function (_Component) {
  _inherits(SettingsModal, _Component);

  function SettingsModal() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, SettingsModal);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = SettingsModal.__proto__ || Object.getPrototypeOf(SettingsModal)).call.apply(_ref, [this].concat(args))), _this), _this.loadSettingsModal = function (event, _data) {
      switch (_data.type.toLowerCase()) {
        case "charts":
          _this.setState({
            searchText: "",
            selectedGlobalModule: _data.type.toLowerCase(),
            modulePackages: _CHARTMODULES
          });
          break;
        case "gridtable":
          _this.setState({
            searchText: "",
            selectedGlobalModule: _data.type.toLowerCase(),
            modalWidth: "sm",
            selectedModule: _data,
            modalType: "settingsModal",
            modalHeader: "Settings"
          });
          break;
        case "tilecard":
          _this.setState({
            searchText: "",
            selectedGlobalModule: _data.type.toLowerCase(),
            modalWidth: "sm",
            selectedModule: _data,
            modalType: "settingsModal",
            modalHeader: "Settings"
          });
          break;
        default:
          var _request = {
            moduleType: _data.module
          };
          getChartSettings(_request.moduleType).then(function (res) {
            if (res.error) {
              _this.showNotification(res, "error");
            } else {
              res.map(function (_valObj, index) {
                _valObj.label = _valObj.comment;
                if (index <= res.length / 2) _valObj.section = '1';else _valObj.section = '2';
                return _valObj;
              });
              _this.setState({
                modalWidth: "sm",
                modalType: "settingsModal",
                selectedModule: _data,
                chartSettings: _extends({}, _this.state.chartSettings, {
                  section: true,
                  disableSectionHeader: true,
                  controls: res
                }),
                modalHeader: "Settings"
              });
            }
          }).catch(function (err) {
            _this.showNotification(err, "error");
          });
          break;
      }
    }, _this.backToGlobalModuleHandler = function (event) {
      _this.setState({
        searchText: "",
        modulePackages: _GLOBALMODULEPACKAGES,
        selectedGlobalModule: ""
      });
    }, _this.handleFormSubmit = function (event, _formData) {
      var _actionType = _this.state.modalActionType;
      var _data = _formData;
      _data["selectedApp"] = _this.state.selectedApp;
      _data["selectedTable"] = _this.state.selectedTable;
      _data["selectedDimension"] = _this.state.selectedDimension;
      _data["selectedMeasures"] = _this.state.selectedMeasure;
      _data["caption"] = _this.state.widgetCaption;
      _this.props.addChartToWidget(_data, _this.state.selectedModule, _this.state.chartSettings, _actionType); //chartDatas[this.state.selectedModule.type + "Data"]
    }, _this.applySettings = function (event) {
      if (document.getElementById("submitButton")) {
        document.getElementById("submitButton").click();
      } else {
        _this.handleFormSubmit(event, {});
      }
      _this.handleSettingModalClose();
    }, _this.handleSettingModalClose = function () {
      _this.setState({
        open: false,
        modalType: "componentModal",
        modalWidth: "md",
        modalHeader: "Choose component"
      });
      _this.props.closeDialogBox();
    }, _this.addMoreMeasureHandler = function (event) {
      var _measureFieldsList = [].concat(_toConsumableArray(_this.state.measureFieldsList));
      var _totalLen = _measureFieldsList.length + 1;
      var _newMeasure = {
        measure: "measure" + _totalLen,
        type: "type" + _totalLen
      };
      _measureFieldsList.push(_newMeasure);
      var measureFieldsList = _measureFieldsList.map(function (_measure, _index) {
        _measure.measure = "measure" + (_index + 1);
        _measure.type = "type" + (_index + 1);
        return _measure;
      });
      _this.setState({
        measureFieldsList: measureFieldsList
      });
    }, _this.removeMeasureHnadler = function (event, _deleteMeasure) {
      var _measureFieldsList = [].concat(_toConsumableArray(_this.state.measureFieldsList));
      var measureFieldsList = _measureFieldsList.filter(function (_measure, _index) {
        return _measure.measure !== _deleteMeasure.measure;
      });
      _this.setState({
        measureFieldsList: measureFieldsList
      });
    }, _this.handleChangeTable = function (name, type) {
      return function (_value) {
        _this.setState(_defineProperty({}, name, _value));
        if (type === "app" || type === "table") {
          _this.loadDropDownData(type, _value.value);
        }
      };
    }, _this.loadDropDownData = function (type, value) {
      if (type === "app") {
        var _request = {
          "appId": "PRISM",
          "filterId": "resultset_meta_filter",
          "filters": [{
            "field": "app_id",
            "operator": "Equals",
            "value": [value]
          }, {
            "field": "name",
            "operator": "Contains",
            "value": [""]
          }]
        };
        getFilterFields(_request).then(function (res) {
          if (res.error) {
            _this.showNotification(res, "error");
          } else {
            res.map(function (item) {
              item.label = item.id;
              item.value = item.id;
              return item;
            });
            _this.setState({
              tableList: res
            });
          }
        }).catch(function (err) {
          _this.showNotification(err, "error");
        });
      }
      if (type === "table") {
        var _request2 = {
          "appId": "PRISM",
          "filterId": "resultset_meta_columns_filter",
          "filters": [{
            "field": "app_id",
            "operator": "Equals",
            "value": [_this.state.selectedApp.value]
          }, {
            "field": "fieldname",
            "operator": "Contains",
            "value": [""]
          }, {
            "field": "table_id",
            "operator": "Equals",
            "value": [value]
          }]
        };
        getFilterFields(_request2).then(function (res) {
          if (res.error) {
            _this.showNotification(res, "error");
          } else {
            res.map(function (item) {
              item.label = item.fieldname;
              item.value = item.fieldname;
            });
            _this.setState({
              dimensionList: res,
              measuresList: res
            });
          }
        }).catch(function (err) {
          _this.showNotification(err, "error");
        });
      }
    }, _this.handleChange = function (event) {
      _this.setState(_defineProperty({}, event.target.id, event.target.value));
    }, _this.changeModuleHandler = function (event) {
      _this.setState({
        open: true,
        modalWidth: "md",
        modalType: "componentModal",
        modalHeader: "Choose component"
      });
    }, _this.handleClose = function () {
      _this.setState({
        open: false,
        tabName: ''
      });
      _this.backToGlobalModuleHandler();
      _this.props.closeDialogBox();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(SettingsModal, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement(
        Dialog,
        {
          className: "main-dialog",
          maxWidth: modalWidth,
          scroll: 'body',
          open: this.state.open,
          disableBackdropClick: true,
          disableEscapeKeyDown: true,
          transitionDuration: 500,
          'aria-labelledby': 'form-dialog-title'
        },
        _react2.default.createElement(
          DialogTitle,
          { className: 'form-dialog-title', id: 'form-dialog-title' },
          modalType === "settingsModal" ? selectedModule.name + " " + modalHeader : modalHeader,
          _react2.default.createElement(
            'div',
            { className: 'display-flex' },
            _react2.default.createElement(
              Button,
              { color: 'primary', className: 'btn-capitalize',
                onClick: function onClick(event) {
                  return _this2.changeModuleHandler(event, settingsToCompBtn);
                }
              },
              settingsToCompBtn
            )
          )
        ),
        _react2.default.createElement(Divider, { varient: 'middle' }),
        _react2.default.createElement(
          DialogContent,
          { className: 'dialog-body' },
          _react2.default.createElement(
            'div',
            { className: 'settings-container' },
            _react2.default.createElement(
              NoSsr,
              null,
              _react2.default.createElement(Select, {
                className: 'dropdown-box',
                options: applicationList,
                value: selectedApp,
                placeholder: 'Select application',
                components: components,
                onChange: this.handleChangeTable('selectedApp', 'app'),
                isClearable: true
              })
            ),
            _react2.default.createElement(
              NoSsr,
              null,
              _react2.default.createElement(Select, {
                className: 'dropdown-box',
                options: tableList,
                value: selectedTable,
                placeholder: 'Select table',
                components: components,
                onChange: this.handleChangeTable('selectedTable', 'table'),
                isClearable: true
              })
            ),
            this.state.selectedGlobalModule !== "gridtable" && _react2.default.createElement(
              'div',
              null,
              _react2.default.createElement(
                NoSsr,
                null,
                _react2.default.createElement(Select, {
                  className: 'dropdown-box',
                  options: dimensionList,
                  value: selectedDimension,
                  placeholder: 'Choose dimension',
                  components: components,
                  onChange: this.handleChangeTable('selectedDimension', 'dimesion'),
                  isClearable: true
                })
              ),
              measureFieldsList.map(function (_item, _index) {
                return _react2.default.createElement(
                  'div',
                  { className: 'measure-container' },
                  _react2.default.createElement(
                    'div',
                    { className: 'measure-measure' },
                    _react2.default.createElement(Select, {
                      className: 'dropdown-box',
                      options: _MEASURESTYPELIST,
                      value: selectedMeasure[_item.measure],
                      placeholder: 'Choose measure',
                      components: components,
                      onChange: _this2.handleChangeTable(_item.measure, 'measure'),
                      isClearable: true
                    })
                  ),
                  _react2.default.createElement(
                    'div',
                    { className: 'measure-type' },
                    _react2.default.createElement(Select, {
                      className: 'dropdown-box',
                      options: _MEASURESTYPELIST,
                      value: selectedMeasure[_item.type],
                      placeholder: 'Choose measure type',
                      components: components,
                      onChange: _this2.handleChangeTable(_item.type, 'measureType'),
                      isClearable: true
                    })
                  ),
                  _react2.default.createElement(
                    'div',
                    { className: 'measure-add-delete' },
                    measureFieldsList.length > 1 && _react2.default.createElement(
                      Tooltip,
                      { title: 'Remove', 'aria-label': 'Remove' },
                      _react2.default.createElement(
                        IconButton,
                        { color: 'secondary', className: 'delete-btn',
                          onClick: function onClick(event) {
                            return _this2.removeMeasureHnadler(event, _item);
                          }
                        },
                        _react2.default.createElement(MaterialIcon, { icon: 'delete' })
                      )
                    ),
                    measureFieldsList.length - 1 === _index && _react2.default.createElement(
                      Tooltip,
                      { title: 'Add', 'aria-label': 'Add' },
                      _react2.default.createElement(
                        IconButton,
                        { color: 'primary', className: 'add-btn',
                          onClick: _this2.addMoreMeasureHandler
                        },
                        _react2.default.createElement(MaterialIcon, { icon: 'add_box' })
                      )
                    )
                  )
                );
              })
            ),
            _react2.default.createElement(TextField, {
              id: 'widgetCaption',
              label: 'Enter widget title',
              variant: 'outlined',
              InputLabelProps: { shrink: true },
              value: widgetCaption,
              className: 'widget-text-field',
              onChange: this.handleChange
            }),
            this.state.selectedGlobalModule !== "gridtable" && _react2.default.createElement(
              'div',
              null,
              chartSettings.controls.length && _react2.default.createElement(GenericForm, { FormData: chartSettings, formSubmit2: this.handleFormSubmit })
            )
          )
        ),
        _react2.default.createElement(
          DialogActions,
          { className: 'dialog-footer' },
          _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(
              Button,
              { className: 'btn-capitalize', onClick: this.handleSettingModalClose, color: 'primary' },
              'Close'
            ),
            _react2.default.createElement(
              Button,
              { className: 'btn-capitalize', onClick: this.applySettings, color: 'primary' },
              modalActionType
            )
          )
        )
      );
    }
  }]);

  return SettingsModal;
}(_react.Component);

exports.default = SettingsModal;