'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _core = require('@material-ui/core');

require('../../styles/dialog.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TabModal = function (_Component) {
  _inherits(TabModal, _Component);

  function TabModal() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, TabModal);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TabModal.__proto__ || Object.getPrototypeOf(TabModal)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      open: _this.props.openModal,
      tabId: _this.props.datas && _this.props.datas.tabId,
      tabName: _this.props.modalTabName || "",
      tabPosition: _this.props.modalTabPosition || ""
    }, _this.handleChange = function (event) {
      _this.setState(_defineProperty({}, event.target.id, event.target.value));
    }, _this.handleCreateUpdate = function (event) {
      var _newTab = {
        tabId: _this.state.tabId,
        tabName: _this.state.tabName,
        tabSequence: Number(_this.state.tabPosition)
      };
      _this.props.handleCreateUpdate(_newTab, _this.props.modalActionType);
      _this.handleClose();
    }, _this.handleClose = function () {
      _this.setState({
        open: false,
        tabName: ''
      });
      _this.props.closeDialogBox();
    }, _this.handleRemoveTab = function (event) {
      _this.props.handleRemoveTab(event, _this.state.tabId);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TabModal, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          modalWidth = _props.modalWidth,
          modalActionType = _props.modalActionType,
          tabCounts = _props.tabCounts;
      var _state = this.state,
          tabName = _state.tabName,
          tabPosition = _state.tabPosition;

      return _react2.default.createElement(
        _core.Dialog,
        {
          className: "main-dialog",
          maxWidth: modalWidth,
          scroll: 'body',
          open: this.state.open,
          disableBackdropClick: true,
          disableEscapeKeyDown: true,
          transitionDuration: 500,
          'aria-labelledby': 'form-dialog-title'
        },
        _react2.default.createElement(
          _core.DialogTitle,
          { className: 'form-dialog-title', id: 'form-dialog-title' },
          modalActionType && modalActionType.toLowerCase() === 'update' ? "Edit tab" : "Add new tab"
        ),
        _react2.default.createElement(_core.Divider, { varient: 'middle' }),
        _react2.default.createElement(
          _core.DialogContent,
          { className: 'dialog-body' },
          _react2.default.createElement(
            'div',
            { className: 'tab-container' },
            _react2.default.createElement(_core.TextField, {
              autoFocus: true,
              id: 'tabName',
              label: 'Name',
              type: 'email',
              value: tabName,
              variant: 'outlined',
              className: 'text-field btn-mgnTB',
              onChange: this.handleChange
            }),
            _react2.default.createElement(_core.TextField, {
              id: 'tabPosition',
              label: 'Position',
              value: tabPosition,
              type: 'number',
              variant: 'outlined',
              className: 'text-field btn-mgnTB',
              onChange: this.handleChange
            }),
            _react2.default.createElement(
              'div',
              null,
              tabCounts > 1 && modalActionType && modalActionType.toLowerCase() === 'update' ? _react2.default.createElement(
                _core.Button,
                { color: 'secondary', className: 'btn-mgnTB btn-capitalize', onClick: this.handleRemoveTab },
                'Remove Tab'
              ) : null
            )
          )
        ),
        _react2.default.createElement(
          _core.DialogActions,
          { className: 'dialog-footer' },
          _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(
              _core.Button,
              { className: 'btn-capitalize', onClick: this.handleClose, color: 'primary' },
              'Close'
            ),
            _react2.default.createElement(
              _core.Button,
              { className: 'btn-capitalize', onClick: this.handleCreateUpdate, color: 'primary' },
              modalActionType
            )
          )
        )
      );
    }
  }]);

  return TabModal;
}(_react.Component);

exports.default = TabModal;