'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _core = require('@material-ui/core');

var _materialIcons = require('./commonComponents/materialIcons');

var _materialIcons2 = _interopRequireDefault(_materialIcons);

var _Add = require('@material-ui/icons/Add');

var _Add2 = _interopRequireDefault(_Add);

var _modalDiolog = require('./modalDiolog');

var _modalDiolog2 = _interopRequireDefault(_modalDiolog);

var _tabContainer = require('./tabContainer');

var _tabContainer2 = _interopRequireDefault(_tabContainer);

var _tabAction = require('../actions/tabAction');

var _layoutAction = require('../actions/layoutAction');

var _notifications = require('./commonComponents/notifications');

var _notifications2 = _interopRequireDefault(_notifications);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function compare(a, b) {
  if (a.tabSequence < b.tabSequence) {
    return -1;
  }
  if (a.tabSequence > b.tabSequence) {
    return 1;
  }
  return 0;
}

var styles = function styles(theme) {
  return {
    root: {
      flexGrow: 1,
      width: '100%',
      backgroundColor: theme.palette.background.paper
    },
    padding0: {
      padding: 0,
      '& div ul': {
        padding: 0
      }
    },
    navigationBarShadow: {
      boxShadow: "0px 1px 1px -1px rgba(0,0,0,0.2), 0px 0px 1px 0px rgba(0,0,0,0.14), 0px 0px 0px 0px rgba(0,0,0,0.12)"
    },
    tabStyle: {
      minWidth: 50,
      textTransform: "capitalize"
    },
    pushRight: {
      position: 'absolute',
      right: 0
    },
    listItem: {
      cursor: 'pointer'
    }
  };
};

var NavigationBar = function (_PureComponent) {
  _inherits(NavigationBar, _PureComponent);

  function NavigationBar() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, NavigationBar);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = NavigationBar.__proto__ || Object.getPrototypeOf(NavigationBar)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      anchorEl: null,
      tabsArr: [{ tabId: _this.props.datas.tabId, tabName: "Main", tabSequence: 0 }],
      widgetDatas: [],
      dashboardData: _this.props.dashboardData,
      tabName: '',
      tabIndex: 0,
      actionType: 'Create',
      openModalDialog: false,
      toastOpen: false,
      toastMessage: null,
      toastVariant: null,
      datas: _this.props.datas
    }, _this.handleChange = function (event, _value, _index) {
      _this.setState({
        tabIndex: _index,
        widgetDatas: _this.state.tabsArr[_value],
        datas: _extends({}, _this.state.datas, {
          tabId: _this.state.tabsArr[_value] && _this.state.tabsArr[_value].tabId,
          layoutId: _this.state.tabsArr[_value] && _this.state.tabsArr[_value].layout.layoutId
        })
      });
    }, _this.closeDialogBox = function () {
      _this.setState({
        openModalDialog: false
      });
    }, _this.addTabs = function (event) {
      _this.setState({
        openModalDialog: true,
        tabName: '',
        tabIndex: _this.state.tabsArr.length,
        actionType: 'Create'
      });
    }, _this.removeTab = function (event, _tabId) {
      _this.reCreateTabs({ tabId: _tabId }, "remove");
    }, _this.editTab = function (event, _tabDetails) {
      if (_this.props.allowEdit) {
        _this.setState({
          openModalDialog: true,
          layoutId: _this.state.datas.layoutId,
          tabId: _tabDetails.tabId,
          tabName: _tabDetails.tabName,
          tabIndex: _tabDetails.tabSequence,
          actionType: 'Update'
        });
      }
    }, _this.reCreateTabs = function (_newTab, _type) {
      var navTabs = [].concat(_toConsumableArray(_this.state.tabsArr));
      var _tabIndex = navTabs.findIndex(function (_data) {
        return _data.tabId === _newTab.tabId;
      });
      switch (_type.toLowerCase()) {
        case "update":
          var _saveTabReq = {
            "dashBoardId": _this.props.datas.dashboardId,
            "layoutId": _newTab.layoutId,
            "tabId": _newTab.tabId,
            "tabName": _newTab.tabName,
            "tabSequence": _newTab.tabSequence,
            "theme": ""
          };
          (0, _tabAction.saveTab)(_saveTabReq).then(function (res) {
            if (res.error) {
              _this.showNotification(res, "error");
            } else {
              _this.showNotification(res, "success");
              navTabs.splice(_tabIndex, 1, _newTab);
              _this.drawTabLayout(navTabs, _newTab, _type);
            }
          }).catch(function (err) {
            _this.showNotification(err, "error");
          });
          break;
        case "remove":
          var _request = _newTab.tabId;
          (0, _tabAction.deleteTab)(_request).then(function (res) {
            if (res.error) {
              _this.showNotification({ message: "Not able to deleted" }, "error");
              _this.setState({
                openModalDialog: false
              });
            } else {
              _this.showNotification({ message: "Layout deleted successfully" }, "success");
              navTabs.splice(_tabIndex, 1);
              _this.drawTabLayout(navTabs, _newTab, _type);
            }
          }).catch(function (err) {
            _this.showNotification({ message: "Not able to deleted" }, "error");
            _this.setState({
              openModalDialog: false
            });
          });
          break;
        default:
          var _createTabReq = {
            "dashBoardId": _this.props.datas.dashboardId,
            "layoutId": _this.props.datas.dashboardId + "_" + _newTab.tabName.replace(/\s/g, "_") + "_" + _newTab.tabSequence + "_layout",
            "tabId": _this.props.datas.dashboardId + "_" + _newTab.tabName.replace(/\s/g, "_") + "_" + _newTab.tabSequence,
            "tabName": _newTab.tabName,
            "tabSequence": _newTab.tabSequence,
            "theme": ""
          };
          var _createLayoutReq = {
            "layoutId": _this.props.datas.dashboardId + "_" + _newTab.tabName.replace(/\s/g, "_") + "_" + _newTab.tabSequence + "_layout",
            "tabId": _this.props.datas.dashboardId + "_" + _newTab.tabName.replace(/\s/g, "_") + "_" + _newTab.tabSequence,
            "theme": ""
          };
          (0, _tabAction.createTab)(_createTabReq).then(function (res) {
            if (res.error) {
              _this.showNotification(res, "error");
            } else {
              (0, _layoutAction.createLayout)(_createLayoutReq).then(function (res) {
                if (res.error) {
                  _this.showNotification(res, "error");
                } else {
                  _this.showNotification(res, "success");
                  _this.setState({
                    datas: _extends({}, _this.props.datas, {
                      "tabId": _createLayoutReq.tabId,
                      "layoutId": _createLayoutReq.layoutId
                    })
                  });
                  _newTab.tabId = _createTabReq.tabId;
                  _newTab.layout = {
                    layoutId: _createTabReq.layoutId,
                    theme: "",
                    widgets: []
                  };
                  delete _newTab.layoutId;
                  navTabs.splice(_tabIndex, 0, _newTab);
                  _this.drawTabLayout(navTabs, _newTab, _type);
                }
              }).catch(function (err) {
                _this.showNotification(err, "error");
              });
            }
          }).catch(function (err) {
            _this.showNotification(err, "error");
          });
          break;
      }
    }, _this.showNotification = function (res, _type) {
      _this.setState({
        toastOpen: true,
        toastMessage: res.message,
        toastVariant: _type
      });
    }, _this.drawTabLayout = function (navTabs, _newTab, type) {

      /* let _navTabs = navTabs.map((_tab, _ind) => {
        if (_tab.tabSequence > _newTab.tabSequence && _type !== 'remove') {
          _tab.tabSequence += 1;
        } else if (_type === 'remove') {
          _tab.tabSequence = _ind;
        }
        return _tab;
      }); */
      var _tabIndex = 0,
          _type = type.toLowerCase();
      if (_type === 'update') {
        _tabIndex = _newTab.tabSequence;
      } else {
        _tabIndex = navTabs.length - 1;
      }

      ;
      _this.setState(_extends({}, _this.state, {
        tabsArr: [].concat(_toConsumableArray(navTabs)),
        tabIndex: _tabIndex,
        widgetDatas: [].concat(_toConsumableArray(_this.state.tabsArr))[_tabIndex],
        openModalDialog: false
      }));
    }, _this.handleClick = function (event) {
      _this.setState({
        anchorEl: event.currentTarget
      });
    }, _this.handleClose = function () {
      _this.setState({
        anchorEl: null
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(NavigationBar, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      if (this.props.tabDatas && this.props.tabDatas.length) {
        this.setState({
          tabsArr: this.props.tabDatas,
          widgetDatas: this.props.tabDatas.find(function (_data) {
            return _data.tabSequence === 0;
          })
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          classes = _props.classes,
          allowEdit = _props.allowEdit;
      var _state = this.state,
          tabIndex = _state.tabIndex,
          tabsArr = _state.tabsArr,
          anchorEl = _state.anchorEl,
          widgetDatas = _state.widgetDatas,
          toastOpen = _state.toastOpen,
          toastVariant = _state.toastVariant,
          toastMessage = _state.toastMessage,
          openModalDialog = _state.openModalDialog;

      return _react2.default.createElement(
        'div',
        { className: classes.root },
        _react2.default.createElement(
          _core.Snackbar,
          {
            anchorOrigin: { vertical: "top", horizontal: "right" },
            open: toastOpen,
            autoHideDuration: 3000,
            onClose: function onClose() {
              _this2.setState({ toastOpen: false });
            }
          },
          _react2.default.createElement(_notifications2.default, {
            variant: toastVariant,
            message: toastMessage,
            onClose: function onClose() {
              _this2.setState({ toastOpen: false });
            }
          })
        ),
        _react2.default.createElement(_modalDiolog2.default, {
          tabDetails: widgetDatas,
          datas: this.state.datas,
          reCreateTabs: this.reCreateTabs,
          closeDialogBox: this.closeDialogBox,
          isOpen: openModalDialog,
          tabName: this.state.tabName,
          tabCounts: tabsArr.length,
          tabSequence: this.state.tabIndex,
          modalActionType: this.state.actionType,
          removeTab: this.removeTab
        }),
        _react2.default.createElement(
          _core.AppBar,
          {
            position: 'static',
            color: 'default',
            className: !allowEdit ? classes.navigationBarShadow : ""
          },
          _react2.default.createElement(
            _core.Tabs,
            {
              value: tabIndex,
              variant: 'scrollable',
              scrollButtons: tabsArr.length > 6 ? "on" : "off",
              indicatorColor: 'primary',
              textColor: 'primary'
            },
            tabsArr.sort(compare).map(function (_tab, _ind) {
              return _react2.default.createElement(_core.Tab, {
                key: "tab" + _ind,
                label: _tab.tabName,
                className: classes.tabStyle,
                onDoubleClick: function onDoubleClick(event) {
                  return _this2.editTab(event, _tab);
                },
                onClick: function onClick(event) {
                  return _this2.handleChange(event, _ind, _tab.tabSequence);
                }
              });
            }),
            allowEdit && _react2.default.createElement(_core.Tab, { icon: _react2.default.createElement(_Add2.default, null), className: classes.tabStyle, onClick: this.addTabs })
          )
        ),
        _react2.default.createElement(_tabContainer2.default, {
          containArr: tabsArr,
          currentTab: this.state.tabIndex,
          datas: this.state.datas,
          widgetDatas: widgetDatas,
          allowEdit: allowEdit
        }),
        _react2.default.createElement(
          _core.Menu,
          {
            id: 'simple-menu',
            className: classes.padding0,
            anchorEl: anchorEl,
            open: Boolean(anchorEl),
            onClose: this.handleClose },
          _react2.default.createElement(
            _core.MenuItem,
            { onClick: this.handleClose },
            'Components'
          ),
          _react2.default.createElement(
            _core.MenuItem,
            { onClick: this.handleClose },
            'Save changes'
          ),
          _react2.default.createElement(
            _core.MenuItem,
            { onClick: this.handleClose },
            'Edit mode'
          ),
          _react2.default.createElement(
            _core.MenuItem,
            { onClick: this.handleClose },
            'Clear All Widgets'
          )
        )
      );
    }
  }]);

  return NavigationBar;
}(_react.PureComponent);

exports.default = (0, _core.withStyles)(styles)(NavigationBar);