"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _core = require("@material-ui/core");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var borderStyle = {
    border: "1px solid #a2b1c6",
    borderCollapse: "collapse",
    padding: 10
};

var headerStyle = {
    border: "1px solid #a2b1c6",
    borderCollapse: "collapse",
    padding: 10,
    background: "#f2f5fa"
};

var PivotTable = function (_React$Component) {
    _inherits(PivotTable, _React$Component);

    function PivotTable(props) {
        _classCallCheck(this, PivotTable);

        var _this = _possibleConstructorReturn(this, (PivotTable.__proto__ || Object.getPrototypeOf(PivotTable)).call(this, props));

        _this.rearrangeData = function (col, colArr) {
            var finalColArr = [];
            for (var k = Object.keys(col).length - 1; k >= 0; k--) {
                var __key = Object.keys(col)[k];
                var colArrComp = finalColArr;
                for (var i = 0; i < col[__key].length; i++) {
                    var temArr = [];
                    for (var j = 0; j < colArrComp.length; j++) {
                        if (k === 0) {
                            if (colArr.includes(col[__key][i] + " | " + colArrComp[j])) {
                                temArr.push(col[__key][i] + " | " + colArrComp[j]);
                            }
                        } else {
                            temArr.push(col[__key][i] + " | " + colArrComp[j]);
                        }
                    }
                    if (!colArrComp.length) {
                        finalColArr = col[__key];
                        break;
                    } else if (i === 0) {
                        finalColArr = [].concat(temArr);
                    } else {
                        finalColArr = [].concat(_toConsumableArray(finalColArr), temArr);
                    }
                }
            }
            return finalColArr;
        };

        _this.state = props;
        return _this;
    }

    _createClass(PivotTable, [{
        key: "render",
        value: function render() {
            var _props = this.props,
                tableData = _props.tableData,
                tableDimention = _props.tableDimention,
                settings = _props.settings;

            var set = {},
                row = {},
                col = {},
                mapData = {};
            var colArr = [],
                rowArr = [],
                finalData = [];
            var data = tableData;
            var dimentions = tableDimention;

            settings && settings.map(function (obj) {
                set[obj.fieldId] = obj.defaultValue;
            });

            //  Storing row and column headers value in their rescpective objects

            dimentions.map(function (obj) {
                switch (obj.dimensionType) {
                    case 'row':
                        row[obj.field] = [];
                        break;
                    case 'column':
                        col[obj.field] = [];
                        break;
                }
            });

            // Extracting Col and row values and storing their in array of their key of object

            data.map(function (_obj, _ind) {
                var strCol = "";
                var strRow = "";
                for (var key in _obj) {
                    if (Object.keys(col).includes(key)) {
                        strCol = strCol ? strCol + " | " + _obj[key] : "" + _obj[key];
                        if (!col[key].includes(_obj[key])) col[key].push(_obj[key] + "");
                    } else if (Object.keys(row).includes(key)) {
                        strRow = strRow ? strRow + " | " + _obj[key] : "" + _obj[key];
                        if (!row[key].includes(_obj[key])) row[key].push(_obj[key] + "");
                    } else {
                        (function () {
                            var tileCount = 0,
                                _startSymbol = "",
                                _endSymbol = "";
                            if ((_obj[key] + "").includes(',')) {
                                var multiVal = _obj[key].split(',');
                                multiVal.map(function (__val) {
                                    tileCount = tileCount + Number(__val);
                                });
                                tileCount = tileCount / multiVal.length;
                            }
                            tileCount = tileCount ? tileCount : Number(_obj[key]);
                            if (set && set.numberFormat) {
                                var _formatArr = set.numberFormat.toLowerCase().split("-");
                                _startSymbol = _formatArr[1] ? _formatArr[1] : null;
                                switch (_formatArr[0].toLowerCase()) {
                                    case 'comma':
                                        tileCount = ("" + tileCount).replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1,');
                                        break;
                                    case 'trillion':
                                        tileCount = ("" + tileCount / Math.pow(10, 12)).replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1,');
                                        _endSymbol = "T";
                                        break;
                                    case 'billion':
                                        tileCount = ("" + tileCount / Math.pow(10, 9)).replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1,');
                                        _endSymbol = "B";
                                        break;
                                    case 'million':
                                        tileCount = ("" + tileCount / Math.pow(10, 6)).replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1,');
                                        _endSymbol = "M";
                                        break;
                                    case 'exponential':
                                        tileCount = "" + tileCount.toExponential(2);
                                        break;
                                    case 'decimal':
                                        tileCount = "" + tileCount.toFixed(2);
                                        break;
                                }
                            }
                            mapData[strCol + strRow] = _startSymbol + tileCount + _endSymbol;
                        })();
                    }
                }
                if (!colArr.includes(strCol)) {
                    colArr.push(strCol);
                }
                if (!rowArr.includes(strRow)) {
                    rowArr.push(strRow);
                }
            });

            // Rearranging the column sequence
            colArr = this.rearrangeData(col, colArr).length ? this.rearrangeData(col, colArr) : [""];
            rowArr = this.rearrangeData(row, rowArr).length ? this.rearrangeData(row, rowArr) : [""];

            //Preparing Final Data Array with muliple column and row as a string
            finalData.push([""].concat(_toConsumableArray(colArr)));
            rowArr.map(function (ithRow, _rowIndex) {
                finalData[_rowIndex + 1] = [ithRow].concat(_toConsumableArray(colArr.map(function (jthCol) {
                    return mapData[jthCol + ithRow];
                })));
            });

            var colHeaders = [];
            if (Object.keys(col).length > 0) {
                finalData[0].map(function (_col, _index) {
                    if (_col) {
                        var colHead = (_col + "").split("|");
                        if (colHeaders.length === 0) {
                            for (var i = 0; i < colHead.length; i++) {
                                colHeaders.push([]);
                            }
                        }
                        colHead.map(function (_colValue, ind) {
                            colHeaders[ind][0] = Object.keys(col)[ind];
                            colHeaders[ind][_index] = _colValue + "";
                        });
                    }
                });
            }
            var item = void 0;
            colHeaders = colHeaders.map(function (row, __inx) {
                var lastVal = "";
                var lastParent = [];
                var count = 1;
                row = row.map(function (val, __ind) {
                    if (item) {
                        item = null;
                    }
                    if (lastVal === val && lastParent.includes(colHeaders[__inx ? __inx - 1 : __inx][__ind])) {
                        val = "";
                        count = count + 1;
                    } else {
                        item = _react2.default.createElement(
                            _core.TableCell,
                            { style: headerStyle, colSpan: count },
                            Object.keys(col).includes(lastVal) ? _react2.default.createElement(
                                "strong",
                                null,
                                _react2.default.createElement(
                                    "i",
                                    null,
                                    lastVal
                                )
                            ) : lastVal
                        );
                        lastParent[__ind] = colHeaders[__inx ? __inx - 1 : __inx][__ind];
                        lastVal = val;
                        count = 1;
                    }
                    if (__ind === row.length - 1) {
                        return _react2.default.createElement(
                            _core.TableCell,
                            { style: headerStyle, colSpan: count },
                            lastVal
                        );
                    }
                    if (item) {
                        return item;
                    }
                });
                row.push(item);
                item = null;
                return row;
            });
            colHeaders = colHeaders.map(function (_arr) {
                _arr.shift();
                return _arr;
            });
            var lastRow = [];
            finalData.shift();

            return _react2.default.createElement(
                "div",
                { style: {
                        float: "left",
                        padding: "5px 40px 40px 40px"
                    } },
                _react2.default.createElement(
                    _core.Table,
                    { style: { width: "100%" } },
                    _react2.default.createElement(
                        _core.TableBody,
                        null,
                        colHeaders.map(function (arr, ind) {
                            return _react2.default.createElement(
                                _core.TableRow,
                                { key: "tableRow" + ind, style: { height: 0 } },
                                Object.keys(row).map(function (val) {
                                    return _react2.default.createElement(_core.TableCell, { style: headerStyle });
                                }),
                                arr
                            );
                        }),
                        Object.keys(row).length ? _react2.default.createElement(
                            _core.TableRow,
                            null,
                            Object.keys(row).map(function (_rowHead, _ind) {
                                return _react2.default.createElement(
                                    _core.TableCell,
                                    { key: "tableCell" + _ind, style: headerStyle },
                                    _react2.default.createElement(
                                        "strong",
                                        null,
                                        _react2.default.createElement(
                                            "i",
                                            { style: { textAlign: "center" } },
                                            _rowHead.replace(/_/g, ' ')
                                        )
                                    )
                                );
                            }),
                            colHeaders[0] && colHeaders[0].map(function (val) {
                                return _react2.default.createElement(_core.TableCell, { style: { borderBottom: "0px" } });
                            })
                        ) : "",
                        finalData.map(function (_row, _rowindex) {
                            var rowHeaders = [];
                            var colsValues = _row.map(function (_col, _index) {
                                if (_index === 0 && _col) {
                                    var __row = (_col + "").split("|");
                                    rowHeaders = __row.map(function (_val, ind) {
                                        if (lastRow[ind] === _val && lastRow[ind - 1] === __row[ind - 1]) {
                                            return _react2.default.createElement(_core.TableCell, { key: "tableCell_1" + _index,
                                                style: _extends({}, headerStyle, {
                                                    borderTop: "0px",
                                                    borderBottom: "0px"
                                                })
                                            });
                                        } else {
                                            return _react2.default.createElement(
                                                _core.TableCell,
                                                { key: "tableCell_1" + _index, style: _rowindex === finalData.length - 1 ? headerStyle : _extends({}, headerStyle, { borderBottom: "0px" }) },
                                                _val
                                            );
                                        }
                                    });
                                    lastRow = __row;
                                } else {
                                    return _react2.default.createElement(
                                        _core.TableCell,
                                        { key: "tableCell_1" + _index, style: borderStyle },
                                        _col
                                    );
                                }
                            });
                            var colSpace = Object.keys(col).length ? _react2.default.createElement(
                                _core.TableCell,
                                { style: { borderBottom: "0px" } },
                                ""
                            ) : "";
                            rowHeaders.length ? rowHeaders : colsValues.shift();

                            return _react2.default.createElement(
                                _core.TableRow,
                                { style: { height: 0 } },
                                rowHeaders.length ? rowHeaders : "",
                                colSpace,
                                colsValues
                            );
                        })
                    )
                )
            );
        }
    }]);

    return PivotTable;
}(_react2.default.Component);

exports.default = PivotTable;