'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _core = require('@material-ui/core');

var _materialIcons = require('./commonComponents/materialIcons');

var _materialIcons2 = _interopRequireDefault(_materialIcons);

var _notifications = require('./commonComponents/notifications');

var _notifications2 = _interopRequireDefault(_notifications);

var _widgetAction = require('../actions/widgetAction');

var _confirmationModal = require('./modals/confirmationModal');

var _confirmationModal2 = _interopRequireDefault(_confirmationModal);

require('../styles/style.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SettingsIcon = function (_Component) {
  _inherits(SettingsIcon, _Component);

  function SettingsIcon() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, SettingsIcon);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = SettingsIcon.__proto__ || Object.getPrototypeOf(SettingsIcon)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      anchorEl: {},
      selectedWidgetIndex: -1,
      openComponent: false,
      toastOpen: false,
      toastMessage: null,
      toastVariant: null,
      openConfirmModal: false
    }, _this.handleComponentToggle = function (event, _widgetId) {
      _this.setState(function (state) {
        return {
          selectedWidgetIndex: _widgetId,
          openComponent: !state.openComponent
        };
      });
      _this.props.setSelectedWidgetId(!_this.state.openComponent, _widgetId);
      _this.props.popoverHandler(!_this.state.openComponent);
    }, _this.handleComponentClose = function (event) {
      if (_this.state.anchorEl[_this.state.selectedWidgetIndex].contains(event.target)) {
        return;
      }
      _this.setState({
        openComponent: false
      });
      _this.props.popoverHandler(false);
    }, _this.handleComponentSettings = function (event, _compData) {
      var _data = _compData.widgetDetails || _compData;
      var _settingsObj = {
        isOpen: true,
        modalWidth: "sm",
        modalType: "settingsModal",
        selectedModule: {
          name: _data.name,
          type: _data.basicChart.type
        },
        chartSettings: _data.widgetSettings,
        modalHeader: "Settings",
        widgetCaption: _data.basicChart.caption,
        modalActionType: "Update",
        widgetId: _this.props.layout.widgetId
      };
      _this.props.openModalDialog(_settingsObj, _compData);
      _this.handleComponentClose(event);
    }, _this.handleComponentRefresh = function (event, layout) {
      _this.props.refreshWidgetData(event, layout);
      _this.handleComponentClose(event);
    }, _this.handleAddComponent = function (event) {
      var _settingsObj = {
        isOpen: true,
        modalWidth: "md",
        modalType: "componentModal",
        modalHeader: "Choose Component",
        modalActionType: "Apply"
      };
      _this.props.openModalDialog(_settingsObj);
      _this.handleComponentClose(event);
    }, _this.handleRemoveComponent = function (event) {
      _this.setState({
        openConfirmModal: true
      });
      _this.handleComponentClose(event);
    }, _this.confirmationActionHandler = function (_action) {
      if (_action === "yes") {
        var widgetId = _this.state.selectedWidgetIndex;
        var _layoutData = _this.props.layoutData,
            _widgetIndex = null;
        _layoutData.layout.map(function (_data, _index) {
          if (_data.widgetId === widgetId) {
            _widgetIndex = _index;
          }
          return _widgetIndex !== null;
        });
        /* if (_layoutData.layout[_widgetIndex].isWidgetAdded) { */
        var _widgetId = _layoutData.layout[_widgetIndex].widgetId;
        (0, _widgetAction.deleteWidget)(_widgetId).then(function (res) {
          _layoutData.layout.splice(_widgetIndex, 1);
          _this.props.removeComponent(_layoutData);
          _this.showNotification(res, "success");
        }).catch(function (err) {
          _this.showNotification(err, "error");
        });
        /* } else {
          _layoutData.layout.splice(_widgetIndex, 1);
          this.props.removeComponent(_layoutData);
        } */
      }
      _this.setState({
        openConfirmModal: false
      });
    }, _this.showNotification = function (res, _type) {
      _this.setState({
        toastOpen: true,
        toastMessage: res.message,
        toastVariant: _type
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(SettingsIcon, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _state = this.state,
          openComponent = _state.openComponent,
          selectedWidgetIndex = _state.selectedWidgetIndex,
          toastOpen = _state.toastOpen,
          toastVariant = _state.toastVariant,
          toastMessage = _state.toastMessage,
          openConfirmModal = _state.openConfirmModal;
      var layout = this.props.layout;

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          _core.Snackbar,
          {
            anchorOrigin: { vertical: "top", horizontal: "right" },
            open: toastOpen,
            autoHideDuration: 3000,
            onClose: function onClose() {
              _this2.setState({ toastOpen: false });
            }
          },
          _react2.default.createElement(_notifications2.default, {
            variant: toastVariant,
            message: toastMessage,
            onClose: function onClose() {
              _this2.setState({ toastOpen: false });
            }
          })
        ),
        _react2.default.createElement(
          _core.IconButton,
          { 'aria-label': 'Settings',
            buttonRef: function buttonRef(node) {
              _this2.state.anchorEl[layout.widgetId] = node;
            },
            className: 'settings-btn',
            'aria-owns': openComponent ? 'menu-list-grow-' + layout.widgetId : undefined,
            'aria-haspopup': 'true',
            style: { position: "absolute", top: 0, left: 0, zIndex: 10 },
            onClick: function onClick(event) {
              return _this2.handleComponentToggle(event, layout.widgetId);
            } },
          _react2.default.createElement(_materialIcons2.default, { icon: 'settings' })
        ),
        _react2.default.createElement(
          _core.Popper,
          {
            style: { zIndex: 1500 },
            open: openComponent,
            anchorEl: this.state.anchorEl[selectedWidgetIndex], transition: true, disablePortal: true },
          function (_ref2) {
            var TransitionProps = _ref2.TransitionProps,
                placement = _ref2.placement;
            return _react2.default.createElement(
              _core.Grow,
              _extends({}, TransitionProps, {
                id: "menu-list-grow-" + selectedWidgetIndex,
                style: { transformOrigin: placement === 'bottom' ? 'center top' : 'center bottom' }
              }),
              _react2.default.createElement(
                _core.Paper,
                { className: 'component-popover' },
                _react2.default.createElement(
                  _core.ClickAwayListener,
                  { onClickAway: _this2.handleComponentClose },
                  _react2.default.createElement(
                    _core.MenuList,
                    null,
                    layout.isWidgetAdded && _react2.default.createElement(
                      _core.MenuItem,
                      { onClick: function onClick(event) {
                          return _this2.handleComponentSettings(event, layout);
                        } },
                      _react2.default.createElement(_materialIcons2.default, { icon: 'settings' }),
                      'Settings'
                    ),
                    !layout.isWidgetAdded && _react2.default.createElement(
                      _core.MenuItem,
                      { onClick: _this2.handleAddComponent },
                      _react2.default.createElement(_materialIcons2.default, { icon: 'add_box' }),
                      'Choose component'
                    ),
                    layout.isWidgetAdded && _react2.default.createElement(
                      _core.MenuItem,
                      { onClick: function onClick(event) {
                          return _this2.handleComponentRefresh(event, layout);
                        } },
                      _react2.default.createElement(_materialIcons2.default, { icon: 'refresh' }),
                      'Refresh'
                    ),
                    _react2.default.createElement(
                      _core.MenuItem,
                      { onClick: function onClick(event) {
                          return _this2.handleRemoveComponent(event);
                        } },
                      _react2.default.createElement(_materialIcons2.default, { icon: 'indeterminate_check_box' }),
                      'Remove component'
                    )
                  )
                )
              )
            );
          }
        ),
        openConfirmModal && _react2.default.createElement(_confirmationModal2.default, {
          modalWidth: 'xs',
          openModal: openConfirmModal,
          modalHeader: 'Delete',
          modalContent: 'Do you really want to delete?',
          yesAction: 'Delete',
          noAction: 'Cancel',
          confirmHandler: this.confirmationActionHandler
        })
      );
    }
  }]);

  return SettingsIcon;
}(_react.Component);

exports.default = SettingsIcon;