'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _core = require('@material-ui/core');

var _gridLayout = require('./gridLayout');

var _gridLayout2 = _interopRequireDefault(_gridLayout);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function TabContainerItem(props) {
  return _react2.default.createElement(
    _core.Typography,
    { component: 'div' },
    props.children
  );
}

var styles = function styles(theme) {
  return {
    root: _extends({}, theme.mixins.gutters(), {
      borderRadius: "0px !important"
    }),
    paddingTB: {
      paddingTop: theme.spacing.unit * 2,
      paddingBottom: theme.spacing.unit * 2
    }
  };
};

var TabContainer = function (_Component) {
  _inherits(TabContainer, _Component);

  function TabContainer() {
    _classCallCheck(this, TabContainer);

    return _possibleConstructorReturn(this, (TabContainer.__proto__ || Object.getPrototypeOf(TabContainer)).apply(this, arguments));
  }

  _createClass(TabContainer, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          classes = _props.classes,
          _props$containArr = _props.containArr,
          containArr = _props$containArr === undefined ? [] : _props$containArr,
          _props$currentTab = _props.currentTab,
          currentTab = _props$currentTab === undefined ? 0 : _props$currentTab,
          _props$widgetDatas = _props.widgetDatas,
          widgetDatas = _props$widgetDatas === undefined ? [] : _props$widgetDatas,
          datas = _props.datas,
          allowEdit = _props.allowEdit;

      return _react2.default.createElement(
        _core.Paper,
        { className: [classes.root, allowEdit ? classes.paddingTB : ""].join(" "), elevation: 1 },
        containArr.map(function (_container, _index) {
          return currentTab === _container.tabSequence && _react2.default.createElement(
            TabContainerItem,
            { key: "contaner" + _index },
            widgetDatas && widgetDatas.layout && widgetDatas.layout.widgets && widgetDatas.layout.widgets.length || allowEdit ? _react2.default.createElement(_gridLayout2.default, {
              datas: datas,
              allowEdit: allowEdit,
              widgetDatas: widgetDatas
            }) : null
          );
        })
      );
    }
  }]);

  return TabContainer;
}(_react.Component);

exports.default = (0, _core.withStyles)(styles)(TabContainer);